#///////////////////////////////////////////////////////////////////////////////
#// directory structure(s)
#///////////////////////////////////////////////////////////////////////////////
HERE      := $(shell pwd)
HOME      := $(shell echo $$HOME)
OS        := $(shell uname)
NGUI_HOME := $(shell echo $$NGUI_HOME)
NGUI_BIN   = $(NGUI_HOME)/bin
NGUI_CFG   = $(NGUI_HOME)/cfg
NGUI_DOC   = $(NGUI_HOME)/doc
NGUI_ETC   = $(NGUI_HOME)/etc
NGUI_SRC   = $(NGUI_HOME)/src
NGUI_NGUI  = $(NGUI_SRC)/ngui
NGUI_EXEC  = $(HOME)/exec

#///////////////////////////////////////////////////////////////////////////////
#// help
#///////////////////////////////////////////////////////////////////////////////
help:
	clear
	@echo ""
	@echo "NGUI $(HERE) Makefile.$(OS) (c) 2008, AURA. All rights reserved."
	@echo "Released under the GPL."
	@echo ""
	@echo "To re-build the code, use:"
	@echo ""
	@echo "% cd $(NGUI_HOME)"
	@echo "% make everything"
	@echo ""
	@echo ""

#///////////////////////////////////////////////////////////////////////////////
#// dump
#///////////////////////////////////////////////////////////////////////////////
dump: help
	@echo "HERE         = $(HERE)"
	@echo "HOME         = $(HOME)"
	@echo "OS           = $(OS)"
	@echo "NGUI_HOME    = $(NGUI_HOME)"
	@echo "NGUI_BIN     = $(NGUI_BIN)"
	@echo "NGUI_CFG     = $(NGUI_CFG)"
	@echo "NGUI_DOC     = $(NGUI_DOC)"
	@echo "NGUI_ETC     = $(NGUI_ETC)"
	@echo "NGUI_SRC     = $(NGUI_SRC)"
	@echo "NGUI_NGUI    = $(NGUI_NGUI)"
	@echo "NGUI_EXEC    = $(NGUI_EXEC)"
	@echo ""

#///////////////////////////////////////////////////////////////////////////////
#// everything
#///////////////////////////////////////////////////////////////////////////////
all:
	-for target in $(TARGETS); do\
	 cd $$target;\
	 make ALL;\
	 cd ${PWD};\
	done

clean:
	-for target in $(TARGETS); do\
	 cd $$target;\
	 make CLEAN;\
	 cd ${PWD};\
	done

everything: init
	-for target in $(TARGETS); do\
	 cd $$target;\
	 make EVERYTHING;\
	 cd ${PWD};\
	done

init:
	if [ ! -d $(NGUI_BIN) ]; then mkdir $(NGUI_BIN); fi
	if [ ! -d $(NGUI_EXEC) ]; then mkdir $(NGUI_EXEC); fi
	if [ ! -e $(HOME)/.ngui ]; then cp $(NGUI_CFG)/ngui.cfg $(HOME)/.ngui; fi
	if [ ! -e $(HOME)/.ngui.pars ]; then cp $(NGUI_CFG)/ngui.pars $(HOME)/.ngui.pars; fi

install:
	-for target in $(TARGETS); do\
	 cd $$target;\
	 make INSTALL;\
	 cd ${PWD};\
	done

tar:
	tar -czpvf $(NGUI_HOME)/`date +%Y%m%d`.tgz README Makefile cfg/* doc/* etc/* src/ngui/*
tarhere:
	tar -czpvf $(NGUI_HOME)/`date +%Y%m%d`.tgz $(HERE)/*
