#!/bin/csh -f

# macro(s)
alias addenv 'if (:${\!:1}\: !~ *:\!{:2}\:*) setenv \!:1 ${\!:1}\:\!:2'
alias preenv 'if (:${\!:1}\: !~ *:\!{:2}\:*) setenv \!:1 \!:2\:${\!:1}'

# unset everything
unsetenv NGUI_BIN NGUI_CFG NGUI_DOC NGUI_ETC NGUI_SRC NGUI_NGUI \
         NGUI_EXEC NGUI_XOPT NGUI_TELESCOPE NGUI_YEAR \
         NGUI_UTC NGUI_PARS NOCS_GWC

# global environment (NB: change location of NGUI_HOME as appropriate)
if (! $?NGUI_HOME) then
 setenv NGUI_HOME ${HOME}/ngui
endif
setenv NGUI_BIN     ${NGUI_HOME}/bin
setenv NGUI_CFG     ${NGUI_HOME}/cfg
setenv NGUI_DOC     ${NGUI_HOME}/doc
setenv NGUI_ETC     ${NGUI_HOME}/etc
setenv NGUI_SRC     ${NGUI_HOME}/src
setenv NGUI_NGUI    ${NGUI_HOME}/src/ngui

# local environment
setenv NGUI_EXEC   ${HOME}/exec
setenv NGUI_CONFIG ${HOME}/.ngui
setenv NGUI_PARS   ${HOME}/.ngui.pars

# NGUI / NOCS
setenv NGUI_XOPT ${NGUI_CFG}/ngui.xopt
if (! $?NOCS_GWC) then
 setenv NOCS_GWC ${NGUI_CFG}/nocs.gwc
endif

# parameter(s)
setenv NGUI_TELESCOPE kpno_4m
if ( `uname` == "Linux" ) then
 setenv NGUI_YEAR  `/bin/date --utc +%Y`
 setenv NGUI_UTC   `/bin/date --utc +%Y%m%d`
else if ( `uname` == "Darwin" ) then
 setenv NGUI_YEAR  `/bin/date -u +%Y`
 setenv NGUI_UTC   `/bin/date -u +%Y%m%d`
endif

# path(s)
setenv PATH "${NGUI_EXEC}:${NGUI_BIN}:${PATH}"
rehash
