proc nguiBuildFrame { W } {
 # global(s)
 global env nocsErrors nocsGlobals nocsWidgets nguiLocals nguiWidgets
 # top level
 toplevel $W
 wm withdraw $W
 frame ${W}.mb
 pack ${W}.mb -fill x
 # file menu
 menubutton ${W}.mb.file -text File -menu ${W}.mb.file.menu
 pack ${W}.mb.file -side left
 menu ${W}.mb.file.menu
 ${W}.mb.file.menu add command -label "Clear Text Widget"  -command "nocsClear"
 ${W}.mb.file.menu add separator
 ${W}.mb.file.menu add command -label "Show Environment"   -command "nocsShow env"
 ${W}.mb.file.menu add command -label "Show Globals"       -command "nocsShow gbl"
 ${W}.mb.file.menu add command -label "Show Parameters"    -command "nocsShowParams"
 ${W}.mb.file.menu add separator
 ${W}.mb.file.menu add command -label "Show Locals"        -command "nguiShowLocals"
 ${W}.mb.file.menu add command -label "Show Values"        -command "nguiShowValues"
 ${W}.mb.file.menu add separator
 ${W}.mb.file.menu add command -label "Show Filters"       -command nguiShowFilters
 ${W}.mb.file.menu add separator
 ${W}.mb.file.menu add command -label Exit                 -command "nocsExit $nocsGlobals(SYSLEV) 0"
 # options menu
 menubutton ${W}.mb.options -text Options -menu ${W}.mb.options.menu
 pack ${W}.mb.options -side left
 menu ${W}.mb.options.menu
 ${W}.mb.options.menu add command -label "Use Filter(s) for Semester:"  -command ""
 ${W}.mb.options.menu add radiobutton -label "  2007B"  -value 2007B  -variable nguiLocals(SEMESTER)
 ${W}.mb.options.menu add radiobutton -label "  2008A"  -value 2008A  -variable nguiLocals(SEMESTER)
 ${W}.mb.options.menu add radiobutton -label "  2008B"  -value 2008B  -variable nguiLocals(SEMESTER)
 ${W}.mb.options.menu add radiobutton -label "  2009A"  -value 2009A  -variable nguiLocals(SEMESTER)
 ${W}.mb.options.menu add radiobutton -label "  2009B"  -value 2009B  -variable nguiLocals(SEMESTER)
 # help menu
 menubutton ${W}.mb.help -text Help -menu ${W}.mb.help.menu
 pack ${W}.mb.help -side right
 menu ${W}.mb.help.menu
 ${W}.mb.help.menu add command -label "About NGUI..." -command "nocsAbout $W"
 # build the widget tree and bind it
 set nguiWidget [nguiBuildWidgets $W]
 pack $nguiWidget
 # set wm parameters
 wm title      $W "NOAO Extremely Wide-Field Infra-Red Mosaic Imaging Camera"
 wm iconname   $W ngui
 wm iconbitmap $W @$env(NGUI_CFG)/ngui.xbm
 wm minsize    $W 500 375
 wm protocol   $W WM_DELETE_WINDOW "nocsExit $nocsGlobals(SYSLEV) 0"
 # initialise the task
 after $nocsGlobals(DELAY)
 update idletasks
 wm withdraw .
 wm deiconify $W
 return $W
}
