proc nguiBuildWidgets { W } {
 # global(s)
 global env nocsErrors nocsGlobals nocsWidgets nguiLocals nguiWidgets nocsVersions
 # create top level (tl)
 set tl [frame ${W}.main]
 # create top frame (tf), middle frame (mf) and bottom frame (bf)
 set tf [frame ${tl}.ft]
 set mf [frame ${tl}.fm -relief sunken -bd 2]
 set bf [frame ${tl}.fb -relief sunken -bd 2]
 set lf [frame ${tl}.fl -relief sunken -bd 2]
 pack $tf $mf $bf $lf -in $tl -fill both -expand yes -side top
 # create scrolling region for output (TW=text_pane SB=scroll_bar)
 set nocsWidgets(SB) [scrollbar ${tf}.scrollbar -orient vertical -relief sunken -bd 2]
 set nocsWidgets(TW) [text ${tf}.text -state disabled -wrap word -relief sunken -bd 2 -width 0]
 $nocsWidgets(SB) configure -command "$nocsWidgets(TW) yview"
 $nocsWidgets(TW) configure -yscroll "$nocsWidgets(SB) set"
 pack $nocsWidgets(SB) -in $tf -side right -fill y
 pack $nocsWidgets(TW) -in $tf -side right -fill both -expand yes
 # create checkbutton(s) for include commands
 set mf1 [frame ${mf}.mf1]
 set mf2 [frame ${mf}.mf2]
 pack $mf1 $mf2 -fill both -expand yes -side top 
 set nguiWidgets(CMD_C1_0) [checkbutton ${mf1}.c0 -fg purple -variable nguiLocals(IEC) -text "ERROR Cmnds"]
 set nguiWidgets(CMD_C1_1) [checkbutton ${mf1}.c1 -fg purple -variable nguiLocals(IBC) -text "BIAS Cmnds"]
 set nguiWidgets(CMD_C1_2) [checkbutton ${mf1}.c2 -fg purple -variable nguiLocals(IFC) -text "FILTER Cmnds"]
 set nguiWidgets(CMD_C1_3) [checkbutton ${mf1}.c3 -fg purple -variable nguiLocals(IGC) -text "GUIDER Cmnds"]
 set nguiWidgets(CMD_C1_4) [checkbutton ${mf1}.c4 -fg purple -variable nguiLocals(ISC) -text "SLEW Cmnds"]
 pack $nguiWidgets(CMD_C1_0) $nguiWidgets(CMD_C1_1) $nguiWidgets(CMD_C1_2) $nguiWidgets(CMD_C1_3) $nguiWidgets(CMD_C1_4) -side left -fill both -expand yes 
 set nguiWidgets(CMD_C2_0) [checkbutton ${mf2}.c0 -fg blue -variable nguiLocals(DFL) -text "Dome Lamp Flag"]
 set nguiWidgets(CMD_C2_1) [checkbutton ${mf2}.c1 -fg blue -variable nguiLocals(ABM) -text "Allow Brownian Motion"]
 pack $nguiWidgets(CMD_C2_0) -side left
 pack $nguiWidgets(CMD_C2_1) -side right
 # create four frames left to right
 set bf1 [frame ${bf}.bf1]
 set bf2 [frame ${bf}.bf2]
 set bf3 [frame ${bf}.bf3]
 set bf4 [frame ${bf}.bf4]
 pack $bf1 $bf2 $bf3 $bf4 -in $bf -fill both -expand yes -side left 
 # off-sky calibration commands
 set nguiWidgets(CMD_B_DARK)                [button ${bf1}.b1 -width 20 -text Dark             -bg aquamarine -fg black]
 set nguiWidgets(CMD_B_TEST)                [button ${bf1}.b2 -width 20 -text Test             -bg aquamarine -fg black]
 set nguiWidgets(CMD_B_DOMEFLAT)            [button ${bf1}.b3 -width 20 -text DomeFlat         -bg aquamarine -fg black]
 set nguiWidgets(CMD_B_DOMEFLATSEQUENCE)    [button ${bf1}.b4 -width 20 -text DomeFlatSequence -bg aquamarine -fg black]
 set nguiWidgets(CMD_B_PTCURVE)             [button ${bf1}.b5 -width 20 -text PTCurve          -bg aquamarine -fg black]
 pack $nguiWidgets(CMD_B_DARK) $nguiWidgets(CMD_B_TEST) $nguiWidgets(CMD_B_DOMEFLAT) \
      $nguiWidgets(CMD_B_DOMEFLATSEQUENCE) $nguiWidgets(CMD_B_PTCURVE) -in $bf1 -expand yes -fill both -side top 
 # on-sky calibration commands
 set nguiWidgets(CMD_B_TWILIGHTFLAT)      [button ${bf2}.b1 -width 20 -text TwilightFlat      -bg azure      -fg black]
 set nguiWidgets(CMD_B_SKYFLAT)           [button ${bf2}.b2 -width 20 -text SkyFlat           -bg azure      -fg black]
 set nguiWidgets(CMD_B_SKYFLATWITHOFFSET) [button ${bf2}.b3 -width 20 -text SkyFlatWithOffset -bg azure      -fg black]
 set nguiWidgets(CMD_B_STANDARD)          [button ${bf2}.b4 -width 20 -text Standard          -bg azure      -fg black]
 set nguiWidgets(CMD_B_FOCUS)             [button ${bf2}.b5 -width 20 -text Focus             -bg azure      -fg black]
 pack $nguiWidgets(CMD_B_TWILIGHTFLAT) $nguiWidgets(CMD_B_SKYFLAT) $nguiWidgets(CMD_B_SKYFLATWITHOFFSET) \
      $nguiWidgets(CMD_B_STANDARD) $nguiWidgets(CMD_B_FOCUS) -in $bf2 -expand yes -fill both -side top 
 # on-sky science commands
 set nguiWidgets(CMD_B_DITHERSTARE)       [button ${bf3}.b1 -width 20 -text DitherStare       -bg lavender   -fg black]
 set nguiWidgets(CMD_B_QUICKLOOK)         [button ${bf3}.b2 -width 20 -text QuickLook         -bg lavender   -fg black]
 set nguiWidgets(CMD_B_DEEPSPARSE)        [button ${bf3}.b3 -width 20 -text DeepSparse        -bg lavender   -fg black]
 set nguiWidgets(CMD_B_DEEPRICH)          [button ${bf3}.b4 -width 20 -text DeepRich          -bg lavender   -fg black]
 set nguiWidgets(CMD_B_SETPROJECT)        [button ${bf3}.b5 -width 20 -text "Set Project"     -bg thistle    -fg black]
 pack $nguiWidgets(CMD_B_DITHERSTARE) $nguiWidgets(CMD_B_QUICKLOOK) $nguiWidgets(CMD_B_DEEPSPARSE) \
      $nguiWidgets(CMD_B_DEEPRICH) $nguiWidgets(CMD_B_SETPROJECT) -in $bf3 -expand yes -fill both -side top 
 set nguiWidgets(CMD_B_QUICKMAP)          [button ${bf4}.b1 -width 20 -text QuickMap          -bg lavender   -fg black]
 set nguiWidgets(CMD_B_QUICKMAPWITHSKY)   [button ${bf4}.b2 -width 20 -text QuickMapWithSky   -bg lavender   -fg black]
 set nguiWidgets(CMD_B_MODMAPSPARSE)      [button ${bf4}.b3 -width 20 -text ModMapSparse      -bg lavender   -fg black]
 set nguiWidgets(CMD_B_MODMAPRICH)        [button ${bf4}.b4 -width 20 -text ModMapRich        -bg lavender   -fg black]
 set nguiWidgets(CMD_B_EXIT)              [button ${bf4}.b5 -width 20 -text Exit              -bg thistle   -fg black]
 pack $nguiWidgets(CMD_B_QUICKMAP) $nguiWidgets(CMD_B_QUICKMAPWITHSKY) $nguiWidgets(CMD_B_MODMAPSPARSE) \
      $nguiWidgets(CMD_B_MODMAPRICH) $nguiWidgets(CMD_B_EXIT) -in $bf4 -expand yes -fill both -side top 
 # lower frame contains copyright etc
 set nocsVersions(BANNER) "$nocsVersions(MODULE) v$nocsVersions(VERSION) $nocsVersions(OWNER), Contact: $nocsVersions(AUTHOR) $nocsVersions(EMAIL)"
 pack [label ${lf}.l -fg blue -textvariable nocsVersions(BANNER) -font -adobe-helvetica-italic-r-normal--*-110-*] -expand yes -fill both -side top 
 # return
 return $tl
}
