proc nguiDthFrame { W } {
 global nguiWidgets
 set nguiWidgets(DTH_F1) [frame ${W}.f1]
 set nguiWidgets(DTH_F2) [frame ${W}.f2]
 pack $nguiWidgets(DTH_F1) $nguiWidgets(DTH_F2) -side top -fill both -expand yes
 set nguiWidgets(DTH_F3) [frame $nguiWidgets(DTH_F2).l]
 set nguiWidgets(DTH_F4) [frame $nguiWidgets(DTH_F2).r]
 pack $nguiWidgets(DTH_F3) $nguiWidgets(DTH_F4) -side left -fill both -expand yes
 nguiDthF1 $nguiWidgets(DTH_F1)
 nguiDthF3 $nguiWidgets(DTH_F3)
 nguiDthF4 $nguiWidgets(DTH_F4)
 nguiDthDisable
}

proc nguiDthF1 { W } {
 pack [label ${W}.l -bg plum -fg black -text "DITHER CONFIGURATION" -font -adobe-helvetica-bold-r-normal--*-180-*] -expand yes -fill both
}

proc nguiDthF2 { W } { }

proc nguiDthF3 { W } {
 global nguiWidgets nguiLocals
 set nguiWidgets(DTH_S_R) [spinbox ${W}.r -textvariable nguiLocals(DTH_S_R_VAL) -increment 1 -from 1 -to 1000]
 set nguiWidgets(DTH_S_D) [spinbox ${W}.d -textvariable nguiLocals(DTH_S_D_VAL) -increment 1 -from 1 -to 1000]
 set nguiWidgets(DTH_S_I) [spinbox ${W}.i -textvariable nguiLocals(DTH_S_I_VAL) -increment 1 -from 1 -to 100]
 set nguiWidgets(DTH_S_S) [spinbox ${W}.s -textvariable nguiLocals(DTH_S_S_VAL) -increment 1 -from 0 -to 100]
 pack [label ${W}.l2 -bg plum -text "RA(\"):"]      $nguiWidgets(DTH_S_R) \
      [label ${W}.l4 -bg plum -text "Dec(\"):"]     $nguiWidgets(DTH_S_D) \
      [label ${W}.l6 -bg plum -text "Iterations:"]  $nguiWidgets(DTH_S_I) \
      [label ${W}.l8 -bg plum -text "Settle(sec):"] $nguiWidgets(DTH_S_S) \
       -side left -fill both -expand yes
}

proc nguiDthF4 { W } {
 global nguiWidgets nguiLocals
 set nguiWidgets(DTH_S_N) [spinbox ${W}.s -textvariable nguiLocals(DTH_S_N_VAL) -increment 1 -from 1 -to 100]
 set nguiWidgets(DTH_S_M) [spinbox ${W}.m -textvariable nguiLocals(DTH_S_M_VAL) -increment 1 -from 1 -to 100]
 set nguiWidgets(DTH_R_X) [radiobutton ${W}.dx -bg plum -variable nguiLocals(DTH_R_VAL) -value X -text 5PX]
 set nguiWidgets(DTH_R_Q) [radiobutton ${W}.dq -bg plum -variable nguiLocals(DTH_R_VAL) -value Q -text 4Q]
 set nguiWidgets(DTH_R_A) [radiobutton ${W}.da -bg plum -variable nguiLocals(DTH_R_VAL) -value A -text Random]
 set nguiWidgets(DTH_R_N) [radiobutton ${W}.dn -bg plum -variable nguiLocals(DTH_R_VAL) -value N -text RAxDec]
 set nguiWidgets(DTH_R_F) [radiobutton ${W}.df -bg plum -variable nguiLocals(DTH_R_VAL) -value F -text "From File"]
 set nguiWidgets(DTH_E_F) [entry ${W}.ef -width 30 -textvariable nguiLocals(DTH_E_F_VAL)]
 set nguiWidgets(DTH_LR)  [label ${W}.lr -bg plum -textvariable nguiLocals(DTH_LR_VAL)]
 set nguiWidgets(DTH_LD)  [label ${W}.ld -bg plum -textvariable nguiLocals(DTH_LD_VAL)]
 pack [label ${W}.l1 -bg plum -text "GEOMETRY:"] $nguiWidgets(DTH_R_X) $nguiWidgets(DTH_R_Q) $nguiWidgets(DTH_R_A) $nguiWidgets(DTH_R_N) $nguiWidgets(DTH_R_F) \
      -side left -fill both -expand yes
}

proc nguiDthAddTrace {} {
 global nguiLocals
 trace variable nguiLocals(DTH_R_VAL) w nguiTraceDither
}

proc nguiDthDelTrace {} {
 global nguiLocals
 trace vdelete nguiLocals(DTH_R_VAL) w nguiTraceDither
}

proc nguiDthDisable { } {
 global nguiWidgets
 $nguiWidgets(DTH_S_R) configure -state disabled
 $nguiWidgets(DTH_S_D) configure -state disabled
 $nguiWidgets(DTH_S_I) configure -state disabled
 $nguiWidgets(DTH_S_N) configure -state disabled
 $nguiWidgets(DTH_S_M) configure -state disabled
 $nguiWidgets(DTH_R_X) configure -state disabled
 $nguiWidgets(DTH_R_Q) configure -state disabled
 $nguiWidgets(DTH_R_A) configure -state disabled
 $nguiWidgets(DTH_R_N) configure -state disabled
}

proc nguiDthEnable { } {
 global nguiWidgets
 $nguiWidgets(DTH_S_R) configure -state normal
 $nguiWidgets(DTH_S_D) configure -state normal
 $nguiWidgets(DTH_S_I) configure -state normal
 $nguiWidgets(DTH_S_N) configure -state normal
 $nguiWidgets(DTH_S_M) configure -state normal
 $nguiWidgets(DTH_R_X) configure -state normal
 $nguiWidgets(DTH_R_Q) configure -state normal
 $nguiWidgets(DTH_R_A) configure -state normal
 $nguiWidgets(DTH_R_N) configure -state normal
}

proc nguiTraceDither { name element op } {
 global nguiLocals nguiWidgets
 if { ${element} != "" } { set name ${name}(${element}) }
 upvar ${name} x
 switch -regexp [string trim [string toupper ${x}]] {
  X {
   $nguiWidgets(DTH_S_R) configure -state normal
   $nguiWidgets(DTH_S_D) configure -state normal
   $nguiWidgets(DTH_S_N) configure -state disabled
   $nguiWidgets(DTH_S_M) configure -state disabled
   set nguiLocals(DTH_LR_VAL) "(Unused):"
   set nguiLocals(DTH_LD_VAL) "(Unused):"
   pack forget $nguiWidgets(DTH_LR) $nguiWidgets(DTH_S_N) $nguiWidgets(DTH_LD) $nguiWidgets(DTH_S_M) $nguiWidgets(DTH_E_F)
  }
  Q {
   $nguiWidgets(DTH_S_R) configure -state disabled
   $nguiWidgets(DTH_S_D) configure -state disabled
   $nguiWidgets(DTH_S_N) configure -state disabled
   $nguiWidgets(DTH_S_M) configure -state disabled
   set nguiLocals(DTH_LR_VAL) "(Unused):"
   set nguiLocals(DTH_LD_VAL) "(Unused):"
   pack forget $nguiWidgets(DTH_LR) $nguiWidgets(DTH_S_N) $nguiWidgets(DTH_LD) $nguiWidgets(DTH_S_M) $nguiWidgets(DTH_E_F)
  }
  A {
   $nguiWidgets(DTH_S_R) configure -state normal
   $nguiWidgets(DTH_S_D) configure -state normal
   $nguiWidgets(DTH_S_N) configure -state normal
   $nguiWidgets(DTH_S_M) configure -state disabled
   set nguiLocals(DTH_LR_VAL) "# Random Steps:"
   set nguiLocals(DTH_LD_VAL) "(Unused):"
   pack forget $nguiWidgets(DTH_LR) $nguiWidgets(DTH_S_N) $nguiWidgets(DTH_LD) $nguiWidgets(DTH_S_M) $nguiWidgets(DTH_E_F)
   pack $nguiWidgets(DTH_LR) $nguiWidgets(DTH_S_N) -side left -fill both -expand yes
  }
  N {
   $nguiWidgets(DTH_S_R) configure -state normal
   $nguiWidgets(DTH_S_D) configure -state normal
   $nguiWidgets(DTH_S_N) configure -state normal
   $nguiWidgets(DTH_S_M) configure -state normal
   set nguiLocals(DTH_S_N_VAL) 1
   set nguiLocals(DTH_S_M_VAL) 1
   set nguiLocals(DTH_LR_VAL) "# RA Steps:"
   set nguiLocals(DTH_LD_VAL) "# Dec Steps:"
   pack forget $nguiWidgets(DTH_LR) $nguiWidgets(DTH_S_N) $nguiWidgets(DTH_LD) $nguiWidgets(DTH_S_M) $nguiWidgets(DTH_E_F)
   pack $nguiWidgets(DTH_LR) $nguiWidgets(DTH_S_N) $nguiWidgets(DTH_LD) $nguiWidgets(DTH_S_M) -side left -fill both -expand yes
  }
  F {
   $nguiWidgets(DTH_S_R) configure -state disabled
   $nguiWidgets(DTH_S_D) configure -state disabled
   $nguiWidgets(DTH_S_N) configure -state disabled
   $nguiWidgets(DTH_S_M) configure -state disabled
   set nguiLocals(DTH_LR_VAL) "Filename:"
   set nguiLocals(DTH_LD_VAL) "(Unused):"
   pack forget $nguiWidgets(DTH_LR) $nguiWidgets(DTH_S_N) $nguiWidgets(DTH_LD) $nguiWidgets(DTH_S_M) $nguiWidgets(DTH_E_F)
   pack $nguiWidgets(DTH_LR) $nguiWidgets(DTH_E_F) -side left -fill both -expand yes
  }
 }
}
