proc nguiEnableRecipe { W R } {
 global env nocsGlobals nocsParams nguiLocals nguiWidgets
 set Ru [string trim [string toupper $R]]
 set Rl [string trim [string tolower $R]]
 # create top-level
 if { [winfo exists $W] } { destroy $W }
 toplevel $W
 wm title $W "$Ru configuration"
 # create frame(s)
 set S [frame ${W}.s -relief sunken -bd 2]
 set O [frame ${W}.o -relief sunken -bd 2]
 set G [frame ${W}.g -relief sunken -bd 2]
 set T [frame ${W}.t -relief sunken -bd 2]
 set D [frame ${W}.d -relief sunken -bd 2]
 set M [frame ${W}.m -relief sunken -bd 2]
 set B [frame ${W}.b -relief sunken -bd 2]
 pack $S $O $G $T $D $M $B -side top -fill both -expand yes
 # SCR frame
 nguiScrFrame ${S}
 # OBS frame
 switch -exact $Ru {
  DFLATS  { nguiObsFrame ${O} C }
  default { nguiObsFrame ${O} R }
 }
 # GPX frame
 switch -exact $Ru {
  PTCURVE  { nguiGpxFrame ${G}; pack forget ${G} }
  DFLATS   { nguiSeqFrame ${G} }
  default  { nguiGpxFrame ${G} }
 }
 # TEL frame
 switch -exact $Ru {
  TFLAT           -
  SFLAT           -
  SFLATO          -
  STANDARD        -
  FOCUS           -
  DITHERSTARE     -
  QUICKLOOK       -
  DEEPSPARSE      -
  DEEPRICH        -
  QUICKMAP        -
  QUICKMAPWITHSKY -
  MODMAPSPARSE    -
  MODMAPRICH      { nguiTelFrame ${T} }
  default         { nguiTelFrame ${T}; pack forget ${T} }
 }
 # DTH frame
 switch -exact $Ru {
  SFLAT           -
  SFLATO          -
  STANDARD        -
  DITHERSTARE     -
  DEEPSPARSE      -
  DEEPRICH        -
  QUICKMAP        -
  QUICKMAPWITHSKY -
  MODMAPSPARSE    -
  MODMAPRICH      { nguiDthFrame ${D} }
  default         { nguiDthFrame ${D}; pack forget ${D} }
 }
 # MAP frame
 switch -exact $Ru {
  DEEPSPARSE      -
  DEEPRICH        -
  QUICKMAP        -
  QUICKMAPWITHSKY -
  MODMAPSPARSE    -
  MODMAPRICH      { nguiMapFrame ${M} }
  default         { nguiMapFrame ${M}; pack forget ${M} }
 }
 # create button(s)
 set nguiWidgets(${Ru}_OK)     [button ${B}.o -text OK]
 set nguiWidgets(${Ru}_HELP)   [button ${B}.h -text "What's This?"]
 set nguiWidgets(${Ru}_CANCEL) [button ${B}.c -text Cancel]
 pack $nguiWidgets(${Ru}_OK) $nguiWidgets(${Ru}_HELP) $nguiWidgets(${Ru}_CANCEL) -side left -fill both -expand y
 $nguiWidgets(${Ru}_OK) configure -command "ngui${Ru}Ok [winfo parent [winfo parent $nguiWidgets(${Ru}_OK)]]"
 $nguiWidgets(${Ru}_HELP) configure -command "nguiGetHelp .help ${Rl}.hlp"
 # recipe-specific cancel options
 switch -exact $Ru {
  DFLATS              { $nguiWidgets(${Ru}_CANCEL) configure -command "nguiSeqDelTrace; destroy [winfo parent [winfo parent $nguiWidgets(${Ru}_CANCEL)]]" }
  TFLAT               { $nguiWidgets(${Ru}_CANCEL) configure -command "nguiTelDelTrace; destroy [winfo parent [winfo parent $nguiWidgets(${Ru}_CANCEL)]]" }
  SFLAT               { $nguiWidgets(${Ru}_CANCEL) configure -command "nguiTelDelTrace; nguiDthDelTrace; destroy [winfo parent [winfo parent $nguiWidgets(${Ru}_CANCEL)]]" }
  SFLATO              { $nguiWidgets(${Ru}_CANCEL) configure -command "nguiTelDelTrace; nguiDthDelTrace; destroy [winfo parent [winfo parent $nguiWidgets(${Ru}_CANCEL)]]" }
  STANDARD            { $nguiWidgets(${Ru}_CANCEL) configure -command "nguiDthDelTrace; destroy [winfo parent [winfo parent $nguiWidgets(${Ru}_CANCEL)]]" }
  DITHERSTARE         { $nguiWidgets(${Ru}_CANCEL) configure -command "nguiDthDelTrace; destroy [winfo parent [winfo parent $nguiWidgets(${Ru}_CANCEL)]]" }
  DEEPSPARSE          { $nguiWidgets(${Ru}_CANCEL) configure -command "nguiDthDelTrace; nguiMapDelTrace; destroy [winfo parent [winfo parent $nguiWidgets(${Ru}_CANCEL)]]" }
  DEEPRICH            { $nguiWidgets(${Ru}_CANCEL) configure -command "nguiDthDelTrace; nguiMapDelTrace; destroy [winfo parent [winfo parent $nguiWidgets(${Ru}_CANCEL)]]" }
  QUICKMAP            { $nguiWidgets(${Ru}_CANCEL) configure -command "nguiDthDelTrace; nguiMapDelTrace; destroy [winfo parent [winfo parent $nguiWidgets(${Ru}_CANCEL)]]" }
  QUICKMAPWITHSKY     { $nguiWidgets(${Ru}_CANCEL) configure -command "nguiDthDelTrace; nguiMapDelTrace; destroy [winfo parent [winfo parent $nguiWidgets(${Ru}_CANCEL)]]" }
  MODMAPSPARSE        { $nguiWidgets(${Ru}_CANCEL) configure -command "nguiDthDelTrace; nguiMapDelTrace; destroy [winfo parent [winfo parent $nguiWidgets(${Ru}_CANCEL)]]" }
  MODMAPRICH          { $nguiWidgets(${Ru}_CANCEL) configure -command "nguiDthDelTrace; nguiMapDelTrace; destroy [winfo parent [winfo parent $nguiWidgets(${Ru}_CANCEL)]]" }
  default             { $nguiWidgets(${Ru}_CANCEL) configure -command "destroy [winfo parent [winfo parent $nguiWidgets(${Ru}_CANCEL)]]" }
 }
 # enable trace(s)
 switch -exact $Ru {
  DFLATS          { nguiSeqAddTrace }
  TFLAT           { nguiTelAddTrace }
  SFLAT           { nguiTelAddTrace; nguiDthAddTrace }
  SFLATO          { nguiTelAddTrace; nguiDthAddTrace }
  STANDARD        { nguiDthAddTrace }
  DITHERSTARE     { nguiDthAddTrace }
  DEEPSPARSE      { nguiDthAddTrace; nguiMapAddTrace }
  DEEPRICH        { nguiDthAddTrace; nguiMapAddTrace }
  QUICKMAP        { nguiDthAddTrace; nguiMapAddTrace }
  QUICKMAPWITHSKY { nguiDthAddTrace; nguiMapAddTrace }
  MODMAPSPARSE    { nguiDthAddTrace; nguiMapAddTrace }
  MODMAPRICH      { nguiDthAddTrace; nguiMapAddTrace }
  default         { }
 }
 # enable widget(s)
 nguiEnableWidgets $Ru
 # set value(s)
 nguiSetValues $Rl
 # set param(s)
 nguiEnableParams $Ru
}
