proc nguiGetRecipeParams { R } {
 global env nocsGlobals nocsParams nguiLocals nguiWidgets
 set Ru [string trim [string toupper $R]]
 set Rl [string trim [string tolower $R]]
 # SCR frame
 nguiScrGet
 # OBS frame
 set nocsParams(NOCNUM) [nguiCheckEntry OBS_S_N_VAL [$nguiWidgets(OBS_S_N) get] NOCNUM 1]
 set nocsParams(NOCSKY) [nguiCheckEntry OBS_S_S_VAL [$nguiWidgets(OBS_S_S) get] NOCSKY 0]
 set nocsParams(NOCFIL) [nguiSetFilterName $nguiLocals(OBS_R_VAL)]
 set nocsParams(NOCFSN) [nguiSetFilterSerialNumber $nguiLocals(OBS_R_VAL)]
 # GPX frame
 switch -exact [string trim [string toupper $Ru]] {
  DFLATS { }
  PTCURVE { }
  default {
   set nocsParams(NOCTIM)   [nguiCheckEntry GPX_E_I_VAL [$nguiWidgets(GPX_E_I) get] NOCTIM  0.7]
   set nocsParams(NOCCOADD) [nguiCheckEntry GPX_E_C_VAL [$nguiWidgets(GPX_E_C) get] NOCCOADD  1]
   set nocsParams(NOCFSMPL) $nguiLocals(GPX_R_F_VAL)
   set nocsParams(NOCDGAVG) $nguiLocals(GPX_R_D_VAL)
   set nocsParams(NOCBIAS)  $nguiLocals(GPX_R_B_VAL)
  }
 }
 # TEL frame
 switch -exact [string trim [string toupper $Ru]] {
  FOCUS {
   set nocsParams(NOCORA)   [$nguiWidgets(TEL_E_OR) get]
   set nocsParams(NOCODEC)  [$nguiWidgets(TEL_E_OD) get]
   set nocsParams(NOCFOCUS) [$nguiWidgets(TEL_E_FS) get]
  }
  QUICKLOOK {
   set nocsParams(NOCPOST) "[$nguiWidgets(TEL_E_R) get] [$nguiWidgets(TEL_E_D) get] [$nguiWidgets(TEL_E_E) get]"
   set nocsParams(NOCORA)  [$nguiWidgets(TEL_E_OR) get]
   set nocsParams(NOCODEC) [$nguiWidgets(TEL_E_OD) get]
   set nocsParams(NOCOFFT) "0 0"
  }
  DEEPRICH {
   set nocsParams(NOCORA)  [$nguiWidgets(TEL_E_OR) get]
   set nocsParams(NOCODEC) [$nguiWidgets(TEL_E_OD) get]
  }
  QUICKMAPWITHSKY {
   set nocsParams(NOCORA)  [$nguiWidgets(TEL_E_OR) get]
   set nocsParams(NOCODEC) [$nguiWidgets(TEL_E_OD) get]
  }
  MODMAPRICH {
   set nocsParams(NOCORA)  [$nguiWidgets(TEL_E_OR) get]
   set nocsParams(NOCODEC) [$nguiWidgets(TEL_E_OD) get]
  }
  default { }
 }
 # recipe-specific parameter(s)
 switch -exact [string trim [string toupper $Ru]] {
  DARK { set nocsParams(NOCTOT) $nocsParams(NOCNUM) }
  TEST { set nocsParams(NOCTOT) $nocsParams(NOCNUM) }
  DFLATON { set nocsParams(NOCTOT) $nocsParams(NOCNUM) }
  DFLATOFF { set nocsParams(NOCTOT) $nocsParams(NOCNUM) }
  DFLATS {
   set nocsParams(NOCTOT) 0
   for { set i 1 } { $i <= [expr $nguiLocals(NFILTER) - 2] } { incr i } {
    if { $nguiLocals(OBS_C_${i}_VAL) == $nocsGlobals(TRUE) } { incr nocsParams(NOCTOT) }
   }
   set nocsParams(NOCTOT) [expr $nocsParams(NOCTOT)*$nocsParams(NOCNUM)*2]
  }
  PTCURVE { }
  TFLAT { set nocsParams(NOCTOT) $nocsParams(NOCNUM) }
  SFLAT { set nocsParams(NOCTOT) [nguiGetDthParams] }
  SFLATO { set nocsParams(NOCTOT) [expr [nguiGetDthParams]*2] }
  STANDARD { set nocsParams(NOCTOT) [nguiGetDthParams] }
  FOCUS { set nocsParams(NOCTOT) [expr $nocsParams(NOCNUM)*[$nguiWidgets(TEL_E_FN) get]+$nocsParams(NOCNUM)] }
  DITHERSTARE { set nocsParams(NOCTOT) [nguiGetDthParams] }
  QUICKLOOK { set nocsParams(NOCTOT) [expr $nocsParams(NOCNUM)*2] }
  DEEPSPARSE {
   set nocsParams(NOCTOT) [nguiGetDthParams]
   set nocsParams(NOCTOT) [expr $nocsParams(NOCTOT) * [nguiGetMapParams]]
  }
  DEEPRICH {
   set nocsParams(NOCTOT) [nguiGetDthParams]
   set nocsParams(NOCTOT) [expr $nocsParams(NOCTOT) * [nguiGetMapParams]]
   set nocsParams(NOCTOT) [expr $nocsParams(NOCTOT) * 2]
  }
  QUICKMAP {
   set nocsParams(NOCTOT) [nguiGetDthParams]
   set nocsParams(NOCTOT) [expr $nocsParams(NOCTOT) * [nguiGetMapParams]]
  }
  QUICKMAPWITHSKY {
   set nDth [nguiGetDthParams]
   set nMap [nguiGetMapParams]
   set nguiLocals(GDRNSKY) [expr (($nguiLocals(GDRNMAP) / $nocsParams(NOCSKY))*$nocsParams(NOCMITER)) +1]
   set nocsParams(NOCTOT) [expr $nDth * ($nMap + $nguiLocals(GDRNSKY))]
  }
  MODMAPSPARSE {
   set nocsParams(NOCTOT) [nguiGetDthParams]
   set nocsParams(NOCTOT) [expr $nocsParams(NOCTOT) * [nguiGetMapParams]]
  }
  MODMAPRICH {
   set nDth [nguiGetDthParams]
   set nMap [nguiGetMapParams]
   set nguiLocals(GDRNSKY) [expr (($nguiLocals(GDRNMAP) / $nocsParams(NOCSKY))*$nocsParams(NOCMITER)) +1]
   set nocsParams(NOCTOT)  [expr $nDth * ($nMap + $nguiLocals(GDRNSKY))]
  }
  default { }
 }
}
