proc nguiGpxFrame { W } {
 global nguiWidgets
 set nguiWidgets(GPX_F1) [frame ${W}.f1]
 set nguiWidgets(GPX_F2) [frame ${W}.f2]
 pack $nguiWidgets(GPX_F1) $nguiWidgets(GPX_F2) -side top -fill both -expand yes
 nguiGpxF1 $nguiWidgets(GPX_F1)
 nguiGpxF2 $nguiWidgets(GPX_F2)
 nguiGpxDisable
}

proc nguiGpxF1 { W } {
 pack [label ${W}.l -bg pink -fg black -text "MONSOON CONFIGURATION" -font -adobe-helvetica-bold-r-normal--*-180-*] -expand yes -fill both
}

proc nguiGpxF2 { W } {
 # global(s)
 global nguiWidgets nguiLocals
 # entry(s)
 set nguiWidgets(GPX_E_I) [entry ${W}.i -textvariable nguiLocals(GPX_E_I_VAL)]
 set nguiWidgets(GPX_E_C) [spinbox ${W}.c -textvariable nguiLocals(GPX_E_C_VAL) -increment 1 -from 1 -to 100]
 set nguiWidgets(GPX_R_1_B) [radiobutton ${W}.b1 -bg pink -variable nguiLocals(GPX_R_B_VAL) -value 400 -text 400]
 set nguiWidgets(GPX_R_2_B) [radiobutton ${W}.b2 -bg pink -variable nguiLocals(GPX_R_B_VAL) -value 600 -text 600]
 set nguiWidgets(GPX_R_3_B) [radiobutton ${W}.b3 -bg pink -variable nguiLocals(GPX_R_B_VAL) -value 800 -text 800]
 set nguiWidgets(GPX_R_1_F) [radiobutton ${W}.f1 -bg pink -variable nguiLocals(GPX_R_F_VAL) -value 1 -text 1]
 set nguiWidgets(GPX_R_2_F) [radiobutton ${W}.f2 -bg pink -variable nguiLocals(GPX_R_F_VAL) -value 2 -text 2]
 set nguiWidgets(GPX_R_3_F) [radiobutton ${W}.f3 -bg pink -variable nguiLocals(GPX_R_F_VAL) -value 4 -text 4]
 set nguiWidgets(GPX_R_4_F) [radiobutton ${W}.f4 -bg pink -variable nguiLocals(GPX_R_F_VAL) -value 8 -text 8]
 set nguiWidgets(GPX_R_5_F) [radiobutton ${W}.f5 -bg pink -variable nguiLocals(GPX_R_F_VAL) -value 16 -text 16]
 set nguiWidgets(GPX_R_1_D) [radiobutton ${W}.d1 -bg pink -variable nguiLocals(GPX_R_D_VAL) -value 1 -text 1]
 set nguiWidgets(GPX_R_2_D) [radiobutton ${W}.d2 -bg pink -variable nguiLocals(GPX_R_D_VAL) -value 2 -text 2]
 set nguiWidgets(GPX_R_3_D) [radiobutton ${W}.d3 -bg pink -variable nguiLocals(GPX_R_D_VAL) -value 4 -text 4]
 set nguiWidgets(GPX_R_4_D) [radiobutton ${W}.d4 -bg pink -variable nguiLocals(GPX_R_D_VAL) -value 8 -text 8]
 set nguiWidgets(GPX_R_5_D) [radiobutton ${W}.d5 -bg pink -variable nguiLocals(GPX_R_D_VAL) -value 16 -text 16]
 # pack
 pack [label ${W}.l2 -bg pink -text "intTime(sec):" -anchor e] $nguiWidgets(GPX_E_I) \
      [label ${W}.l3 -bg pink -text "coadds: " -anchor e] $nguiWidgets(GPX_E_C) \
      [label ${W}.l4 -bg pink -text "bias(mV): " -anchor e] \
      $nguiWidgets(GPX_R_1_B) $nguiWidgets(GPX_R_2_B) $nguiWidgets(GPX_R_3_B) \
      [label ${W}.l5 -bg pink -text "fSamples: " -anchor e] \
      $nguiWidgets(GPX_R_1_F) $nguiWidgets(GPX_R_2_F) $nguiWidgets(GPX_R_3_F) $nguiWidgets(GPX_R_4_F) $nguiWidgets(GPX_R_5_F) \
      [label ${W}.l6 -bg pink -text "digAvgs: " -anchor e] \
      $nguiWidgets(GPX_R_1_D) $nguiWidgets(GPX_R_2_D) $nguiWidgets(GPX_R_3_D) $nguiWidgets(GPX_R_4_D) $nguiWidgets(GPX_R_5_D) \
      -side left -expand yes -fill both
}

proc nguiGpxDisable { } {
 global nguiWidgets
 $nguiWidgets(GPX_E_I)   configure -state disabled
 $nguiWidgets(GPX_E_C)   configure -state disabled
 $nguiWidgets(GPX_R_1_B) configure -state disabled
 $nguiWidgets(GPX_R_2_B) configure -state disabled
 $nguiWidgets(GPX_R_3_B) configure -state disabled
 $nguiWidgets(GPX_R_1_F) configure -state disabled
 $nguiWidgets(GPX_R_2_F) configure -state disabled
 $nguiWidgets(GPX_R_3_F) configure -state disabled
 $nguiWidgets(GPX_R_4_F) configure -state disabled
 $nguiWidgets(GPX_R_5_F) configure -state disabled
 $nguiWidgets(GPX_R_1_D) configure -state disabled
 $nguiWidgets(GPX_R_2_D) configure -state disabled
 $nguiWidgets(GPX_R_3_D) configure -state disabled
 $nguiWidgets(GPX_R_4_D) configure -state disabled
 $nguiWidgets(GPX_R_5_D) configure -state disabled
}

proc nguiGpxEnable { } {
 global nguiWidgets nguiLocals nocsGlobals
 $nguiWidgets(GPX_E_I) configure -state normal
 $nguiWidgets(GPX_E_C) configure -state normal
 if { $nguiLocals(IBC) == $nocsGlobals(TRUE) } {
  $nguiWidgets(GPX_R_1_B) configure -state normal
  $nguiWidgets(GPX_R_2_B) configure -state normal
  $nguiWidgets(GPX_R_3_B) configure -state normal
 }
 $nguiWidgets(GPX_R_1_F) configure -state normal
 $nguiWidgets(GPX_R_2_F) configure -state normal
 $nguiWidgets(GPX_R_3_F) configure -state normal
 $nguiWidgets(GPX_R_4_F) configure -state normal
 $nguiWidgets(GPX_R_5_F) configure -state normal
 $nguiWidgets(GPX_R_1_D) configure -state normal
 $nguiWidgets(GPX_R_2_D) configure -state normal
 $nguiWidgets(GPX_R_3_D) configure -state normal
 $nguiWidgets(GPX_R_4_D) configure -state normal
 $nguiWidgets(GPX_R_5_D) configure -state normal
}
