proc nguiMapA { F V } {
 # global(s)
 global env nocsErrors nocsGlobals nocsWidgets nguiLocals nocsParams nguiWidgets
 set nguiLocals(MAPHR) 0
 set nguiLocals(MAPHD) 0
 set nguiLocals(MAPLR) 0
 set nguiLocals(MAPLD) 0
 set N [$nguiWidgets(MAP_S_N) get]
 set nguiLocals(RUPPERM) [expr abs([$nguiWidgets(MAP_S_R) get])]
 set nguiLocals(DUPPERM) [expr abs([$nguiWidgets(MAP_S_D) get])]
 set nguiLocals(RLOWERM) [expr $nguiLocals(RUPPERM) * -1]
 set nguiLocals(DLOWERM) [expr $nguiLocals(DUPPERM) * -1]
 # series of N frames
 for { set nocsParams(NOCMPOS) 1 } { $nocsParams(NOCMPOS) <= $N } { incr nocsParams(NOCMPOS) } {
  # do offset according to Brownian motion rules
  if { $nguiLocals(ABM) == $nocsGlobals(TRUE) } {
   set nocsParams(NOCMROF) [nguiRandom $nocsGlobals(FALSE) $nguiLocals(RLOWERM) $nguiLocals(RUPPERM)]
   set nocsParams(NOCMDOF) [nguiRandom $nocsGlobals(FALSE) $nguiLocals(DLOWERM) $nguiLocals(DUPPERM)]
   set nguiLocals(MAPHR)   [expr $nguiLocals(MAPHR) + $nocsParams(NOCMROF)]
   set nguiLocals(MAPHD)   [expr $nguiLocals(MAPHD) + $nocsParams(NOCMDOF)]
   set nocsParams(NOCOFFT) "$nocsParams(NOCMROF) $nocsParams(NOCMDOF)"
   nguiSetTelOff $F $nocsParams(NOCOFFT) "offset telescope $nocsParams(NOCOFFT) for map $nocsParams(NOCMPAT), map reference $nocsParams(NOCMPOS) <$nguiLocals(MAPHR),$nguiLocals(MAPHD)> with Brownian motion"
  } else {
   if { $nocsParams(NOCMPOS) > 1 } {
    set nguiLocals(MAPLR) $nocsParams(NOCMROF)
    set nguiLocals(MAPLD) $nocsParams(NOCMDOF)
   }
   set nocsParams(NOCMROF) [nguiRandom $nocsGlobals(FALSE) $nguiLocals(RLOWERM) $nguiLocals(RUPPERM)]
   set nocsParams(NOCMDOF) [nguiRandom $nocsGlobals(FALSE) $nguiLocals(DLOWERM) $nguiLocals(DUPPERM)]
   set nocsParams(NOCOFFT) "[expr $nocsParams(NOCMROF) - $nguiLocals(MAPLR)] [expr $nocsParams(NOCMDOF) - $nguiLocals(MAPLD)]"
   nguiSetTelOff $F $nocsParams(NOCOFFT) "offset telescope $nocsParams(NOCOFFT) for map $nocsParams(NOCMPAT), map reference $nocsParams(NOCMPOS) <$nguiLocals(MAPHR),$nguiLocals(MAPHD)> no Brownian motion"
  }
  # observe
  for { set nocsParams(NOCDREP) 1 } { $nocsParams(NOCDREP) <= $nocsParams(NOCDITER) } { incr nocsParams(NOCDREP) } { nguiDither$nguiLocals(DTH_R_VAL) $F }
  if { $V>0 && [nguiIsModulo $nocsParams(NOCMPOS) $V]==$nocsGlobals(TRUE) } { nguiSkyMapOffset $F }
 }
 # return home
 set nocsParams(NOCMPOS) 1
 if { $nguiLocals(ABM) == $nocsGlobals(TRUE) } {
  set nocsParams(NOCOFFT) "[expr $nguiLocals(MAPHR) * -1] [expr $nguiLocals(MAPHD) * -1]"
 } else {
  set nocsParams(NOCOFFT) "[expr $nocsParams(NOCMROF) * -1] [expr $nocsParams(NOCMDOF) * -1]"
 }
 nguiSetTelOff $F $nocsParams(NOCOFFT) "offset telescope $nocsParams(NOCOFFT) for map $nocsParams(NOCMPAT), return home"
}
