proc nguiMapFrame { W } {
 global nguiWidgets
 set nguiWidgets(MAP_F1) [frame ${W}.f1]
 set nguiWidgets(MAP_F2) [frame ${W}.f2]
 pack $nguiWidgets(MAP_F1) $nguiWidgets(MAP_F2) -side top -fill both -expand yes
 set nguiWidgets(MAP_F3) [frame $nguiWidgets(MAP_F2).l]
 set nguiWidgets(MAP_F4) [frame $nguiWidgets(MAP_F2).r]
 pack $nguiWidgets(MAP_F3) $nguiWidgets(MAP_F4) -side left -fill both -expand yes
 nguiMapF1 $nguiWidgets(MAP_F1)
 nguiMapF3 $nguiWidgets(MAP_F3)
 nguiMapF4 $nguiWidgets(MAP_F4)
 nguiMapDisable
}

proc nguiMapF1 { W } {
 pack [label ${W}.l -bg cyan -fg black -text "MAP CONFIGURATION" -font -adobe-helvetica-bold-r-normal--*-180-*] -expand yes -fill both
}

proc nguiMapF2 { W } { }

proc nguiMapF3 { W } {
 global nguiWidgets nguiLocals
 set nguiWidgets(MAP_S_R) [spinbox ${W}.r -textvariable nguiLocals(MAP_S_R_VAL) -increment 1 -from 1 -to 1000]
 set nguiWidgets(MAP_S_D) [spinbox ${W}.d -textvariable nguiLocals(MAP_S_D_VAL) -increment 1 -from 1 -to 1000]
 set nguiWidgets(MAP_S_I) [spinbox ${W}.i -textvariable nguiLocals(MAP_S_I_VAL) -increment 1 -from 1 -to 100]
 set nguiWidgets(MAP_C_S) [checkbutton ${W}.s -bg cyan -variable nguiLocals(MAP_C_S_VAL) -text "Guider Wait?"]
 pack [label ${W}.l2 -bg cyan -text "RA(\"):"] $nguiWidgets(MAP_S_R) \
      [label ${W}.l4 -bg cyan -text "Dec(\"):"] $nguiWidgets(MAP_S_D) \
      [label ${W}.l6 -bg cyan -text "Iterations:"] $nguiWidgets(MAP_S_I) \
      $nguiWidgets(MAP_C_S) \
      -side left -fill both -expand yes
}

proc nguiMapF4 { W } {
 global nguiWidgets nguiLocals
 set nguiWidgets(MAP_S_N) [spinbox ${W}.s -textvariable nguiLocals(MAP_S_N_VAL) -increment 1 -from 1 -to 100]
 set nguiWidgets(MAP_S_M) [spinbox ${W}.m -textvariable nguiLocals(MAP_S_M_VAL) -increment 1 -from 1 -to 100]
 set nguiWidgets(MAP_R_X) [radiobutton ${W}.dx -bg cyan -variable nguiLocals(MAP_R_VAL) -value X -text 5PX]
 set nguiWidgets(MAP_R_Q) [radiobutton ${W}.dq -bg cyan -variable nguiLocals(MAP_R_VAL) -value Q -text 4Q]
 set nguiWidgets(MAP_R_A) [radiobutton ${W}.da -bg cyan -variable nguiLocals(MAP_R_VAL) -value A -text Random]
 set nguiWidgets(MAP_R_N) [radiobutton ${W}.dn -bg cyan -variable nguiLocals(MAP_R_VAL) -value N -text RAxDec]
 set nguiWidgets(MAP_R_F) [radiobutton ${W}.df -bg cyan -variable nguiLocals(MAP_R_VAL) -value F -text "From File"]
 set nguiWidgets(MAP_E_F) [entry ${W}.ef -width 30 -textvariable nguiLocals(MAP_E_F_VAL)]
 set nguiWidgets(MAP_LR)  [label ${W}.lr -bg cyan -textvariable nguiLocals(MAP_LR_VAL)]
 set nguiWidgets(MAP_LD)  [label ${W}.ld -bg cyan -textvariable nguiLocals(MAP_LD_VAL)]
 pack [label ${W}.l1 -bg cyan -text "GEOMETRY:"] $nguiWidgets(MAP_R_X) $nguiWidgets(MAP_R_Q) $nguiWidgets(MAP_R_A) $nguiWidgets(MAP_R_N) $nguiWidgets(MAP_R_F) -side left -fill both -expand yes
}

proc nguiMapAddTrace {} {
 global nguiLocals
 trace variable nguiLocals(MAP_R_VAL) w nguiTraceMap
}

proc nguiMapDelTrace {} {
 global nguiLocals
 trace vdelete nguiLocals(MAP_R_VAL) w nguiTraceMap
}

proc nguiMapDisable { } {
 global nguiWidgets
 $nguiWidgets(MAP_S_R) configure -state disabled
 $nguiWidgets(MAP_S_D) configure -state disabled
 $nguiWidgets(MAP_S_I) configure -state disabled
 $nguiWidgets(MAP_S_N) configure -state disabled
 $nguiWidgets(MAP_S_M) configure -state disabled
 $nguiWidgets(MAP_R_X) configure -state disabled
 $nguiWidgets(MAP_R_Q) configure -state disabled
 $nguiWidgets(MAP_R_A) configure -state disabled
 $nguiWidgets(MAP_R_N) configure -state disabled
}

proc nguiMapEnable { } {
 global nguiWidgets
 $nguiWidgets(MAP_S_R) configure -state normal
 $nguiWidgets(MAP_S_D) configure -state normal
 $nguiWidgets(MAP_S_I) configure -state normal
 $nguiWidgets(MAP_S_N) configure -state normal
 $nguiWidgets(MAP_S_M) configure -state normal
 $nguiWidgets(MAP_R_X) configure -state normal
 $nguiWidgets(MAP_R_Q) configure -state normal
 $nguiWidgets(MAP_R_A) configure -state normal
 $nguiWidgets(MAP_R_N) configure -state normal
}

proc nguiTraceMap { name element op } {
 global nguiLocals nguiWidgets
 if { ${element} != "" } { set name ${name}(${element}) }
 upvar ${name} x
 switch -regexp [string trim [string toupper ${x}]] {
  X {
   $nguiWidgets(MAP_S_R) configure -state normal
   $nguiWidgets(MAP_S_D) configure -state normal
   $nguiWidgets(MAP_S_N) configure -state disabled
   $nguiWidgets(MAP_S_M) configure -state disabled
   set nguiLocals(MAP_LR_VAL) "(Unused):"
   set nguiLocals(MAP_LD_VAL) "(Unused):"
   pack forget $nguiWidgets(MAP_LR) $nguiWidgets(MAP_S_N) $nguiWidgets(MAP_LD) $nguiWidgets(MAP_S_M) $nguiWidgets(MAP_E_F)
  }
  Q {
   $nguiWidgets(MAP_S_R) configure -state disabled
   $nguiWidgets(MAP_S_D) configure -state disabled
   $nguiWidgets(MAP_S_N) configure -state disabled
   $nguiWidgets(MAP_S_M) configure -state disabled
   set nguiLocals(MAP_LR_VAL) "(Unused):"
   set nguiLocals(MAP_LD_VAL) "(Unused):"
   pack forget $nguiWidgets(MAP_LR) $nguiWidgets(MAP_S_N) $nguiWidgets(MAP_LD) $nguiWidgets(MAP_S_M) $nguiWidgets(MAP_E_F)
  }
  A {
   $nguiWidgets(MAP_S_R) configure -state normal
   $nguiWidgets(MAP_S_D) configure -state normal
   $nguiWidgets(MAP_S_N) configure -state normal
   $nguiWidgets(MAP_S_M) configure -state disabled
   set nguiLocals(MAP_LR_VAL) "# Random Steps:"
   set nguiLocals(MAP_LD_VAL) "(Unused):"
   pack forget $nguiWidgets(MAP_LR) $nguiWidgets(MAP_S_N) $nguiWidgets(MAP_LD) $nguiWidgets(MAP_S_M) $nguiWidgets(MAP_E_F)
   pack $nguiWidgets(MAP_LR) $nguiWidgets(MAP_S_N) -side left -fill both -expand yes
  }
  N {
   $nguiWidgets(MAP_S_R) configure -state normal
   $nguiWidgets(MAP_S_D) configure -state normal
   $nguiWidgets(MAP_S_N) configure -state normal
   $nguiWidgets(MAP_S_M) configure -state normal
   set nguiLocals(MAP_S_N_VAL) 1
   set nguiLocals(MAP_S_M_VAL) 1
   set nguiLocals(MAP_LR_VAL) "# RA Steps:"
   set nguiLocals(MAP_LD_VAL) "# Dec Steps:"
   pack forget $nguiWidgets(MAP_LR) $nguiWidgets(MAP_S_N) $nguiWidgets(MAP_LD) $nguiWidgets(MAP_S_M) $nguiWidgets(MAP_E_F)
   pack $nguiWidgets(MAP_LR) $nguiWidgets(MAP_S_N) $nguiWidgets(MAP_LD) $nguiWidgets(MAP_S_M) -side left -fill both -expand yes
  }
  F {
   $nguiWidgets(MAP_S_R) configure -state disabled
   $nguiWidgets(MAP_S_D) configure -state disabled
   $nguiWidgets(MAP_S_N) configure -state disabled
   $nguiWidgets(MAP_S_M) configure -state disabled
   set nguiLocals(MAP_LR_VAL) "Filename:"
   set nguiLocals(MAP_LD_VAL) "(Unused):"
   pack forget $nguiWidgets(MAP_LR) $nguiWidgets(MAP_S_N) $nguiWidgets(MAP_LD) $nguiWidgets(MAP_S_M) $nguiWidgets(MAP_E_F)
   pack $nguiWidgets(MAP_LR) $nguiWidgets(MAP_E_F) -side left -fill both -expand yes
  }
 }
}
