proc nguiObsFrame { W T } {
 global nguiWidgets
 set nguiWidgets(OBS_F1) [frame ${W}.f1]
 set nguiWidgets(OBS_F2) [frame ${W}.f2]
 pack $nguiWidgets(OBS_F1) $nguiWidgets(OBS_F2) -side top -fill both -expand yes
 set nguiWidgets(OBS_F3) [frame $nguiWidgets(OBS_F2).f3]
 set nguiWidgets(OBS_F4) [frame $nguiWidgets(OBS_F2).f4]
 set nguiWidgets(OBS_F5) [frame $nguiWidgets(OBS_F2).f5]
 pack $nguiWidgets(OBS_F3) $nguiWidgets(OBS_F4) $nguiWidgets(OBS_F5) -side left -fill both -expand yes
 nguiObsF1     $nguiWidgets(OBS_F1)
 nguiObsF2     $nguiWidgets(OBS_F2)
 nguiObsF3     $nguiWidgets(OBS_F3)
 nguiObsF4     $nguiWidgets(OBS_F4)
 nguiObsF5${T} $nguiWidgets(OBS_F5)
 nguiObsSpinDisable
}

proc nguiObsF1 { W } {
 pack [label ${W}.l -fg black -text "OBSERVATION CONFIGURATION" -font -adobe-helvetica-bold-r-normal--*-180-*] -expand yes -fill both
}

proc nguiObsF2 { W } { }

proc nguiObsF3 { W } {
 global nguiWidgets nguiLocals
 set nguiWidgets(OBS_S_N) [spinbox ${W}.s -textvariable nguiLocals(OBS_S_N_VAL) -increment 1 -from 1 -to 100]
 pack [label ${W}.l1 -text "NumObs:"] $nguiWidgets(OBS_S_N) -side left -fill both -expand yes
}

proc nguiObsF4 { W } {
 global nguiWidgets nguiLocals
 set nguiWidgets(OBS_S_S) [spinbox ${W}.s -textvariable nguiLocals(OBS_S_S_VAL) -increment 1 -from 1 -to 100]
 pack [label ${W}.l2 -text "SkyMod:"] $nguiWidgets(OBS_S_S) -side left -fill both -expand yes
}

proc nguiObsF5R { W } {
 global nguiWidgets nguiLocals nocsGlobals
 pack [label ${W}.l -text "Filter:"] -side left -fill both -expand yes
 for { set i 1 } { $i <= $nguiLocals(NFILTER) } { incr i } {
  set L [string trim [lindex [split [lindex $nguiLocals(FILTERS) [expr $i - 1]] $nocsGlobals(DELIM)] 1]]
  set V [string trim [lindex [split [lindex $nguiLocals(FILTERS) [expr $i - 1]] $nocsGlobals(DELIM)] 0]]
  set nguiWidgets(OBS_R_${i}) [radiobutton ${W}.b${i} -variable nguiLocals(OBS_R_VAL) -value "$V" -text "$L"]
  pack $nguiWidgets(OBS_R_${i}) -side left -fill both -expand yes
 }
 nguiObsRadioDisable
}

proc nguiObsF5C { W } {
 global nguiWidgets nguiLocals nocsGlobals
 pack [label ${W}.l -text "Filter(s):" -anchor e] -side left -fill both -expand yes
 for { set i 1 } { $i <= $nguiLocals(NFILTER) } { incr i } {
  set L [string trim [lindex [split [lindex $nguiLocals(FILTERS) [expr $i - 1]] $nocsGlobals(DELIM)] 1]]
  set V [string trim [lindex [split [lindex $nguiLocals(FILTERS) [expr $i - 1]] $nocsGlobals(DELIM)] 0]]
  set nguiWidgets(OBS_C_${i}) [checkbutton ${W}.c${i} -variable nguiLocals(OBS_C_${i}_VAL) -text "$L"]
  pack $nguiWidgets(OBS_C_${i}) -side left -fill both -expand yes
 }
 nguiObsCheckDisable
 nguiObsCheckOff
}

proc nguiObsSpinDisable { } {
 global nguiWidgets
 $nguiWidgets(OBS_S_N) configure -state disabled
 $nguiWidgets(OBS_S_S) configure -state disabled
}

proc nguiObsSpinEnable { F1 F2 } {
 global nguiWidgets nocsGlobals
 if { $F1 == $nocsGlobals(TRUE) } { $nguiWidgets(OBS_S_N) configure -state normal }
 if { $F2 == $nocsGlobals(TRUE) } { $nguiWidgets(OBS_S_S) configure -state normal }
}

proc nguiObsRadioToggleAll { S } {
 global nguiWidgets nguiLocals
 for { set i 1 } { $i <= $nguiLocals(NFILTER) } { incr i } { $nguiWidgets(OBS_R_${i}) configure -state $S }
}
proc nguiObsRadioDisable { } { nguiObsRadioToggleAll disabled }
proc nguiObsRadioEnable  { } { nguiObsRadioToggleAll normal   }

proc nguiObsCheckToggleAll { S } {
 global env nocsGlobals nocsWidgets nguiLocals nguiWidgets
 for { set i 1 } { $i <= $nguiLocals(NFILTER) } { incr i } { $nguiWidgets(OBS_C_${i}) configure -state $S }
}
proc nguiObsCheckDisable { } { nguiObsCheckToggleAll disabled }
proc nguiObsCheckEnable  { } { nguiObsCheckToggleAll normal   }

proc nguiObsRadioToggleFilter { F T } {
 global env nocsGlobals nocsParams nguiLocals nguiWidgets
 set Fu [string trim [string toupper $F]]
 for { set i 1 } { $i <= $nguiLocals(NFILTER) } { incr i } {
  set L [string trim [lindex [split [lindex $nguiLocals(FILTERS) [expr $i - 1]] $nocsGlobals(DELIM)] 1]]
  set V [string trim [lindex [split [lindex $nguiLocals(FILTERS) [expr $i - 1]] $nocsGlobals(DELIM)] 0]]
  if { ${L} == ${Fu} } { $nguiWidgets(OBS_R_${i}) configure -state $T }
 }
}
proc nguiObsRadioDisableFilter { F } { nguiObsRadioToggleFilter $F disabled }
proc nguiObsRadioEnableFilter  { F } { nguiObsRadioToggleFilter $F normal   }

proc nguiObsCheckToggleFilter { F T } {
 global env nocsGlobals nocsWidgets nguiLocals nguiWidgets nocsParams
 set Fu [string trim [string toupper $F]]
 for { set i 1 } { $i <= $nguiLocals(NFILTER) } { incr i } {
  set L [string trim [lindex [split [lindex $nguiLocals(FILTERS) [expr $i - 1]] $nocsGlobals(DELIM)] 1]]
  set V [string trim [lindex [split [lindex $nguiLocals(FILTERS) [expr $i - 1]] $nocsGlobals(DELIM)] 0]]
  if { ${L} == ${Fu} } { $nguiWidgets(OBS_C_${i}) configure -state $T }
 }
}
proc nguiObsCheckDisableFilter { F } { nguiObsCheckToggleFilter $F disabled }
proc nguiObsCheckEnableFilter  { F } { nguiObsCheckToggleFilter $F normal   }

proc nguiObsCheckSetAll { V } {
 global env nocsGlobals nocsWidgets nguiLocals nguiWidgets
 for { set i 1 } { $i <= $nguiLocals(NFILTER) } { incr i } { set nguiLocals(OBS_C_${i}_VAL) $V }
}
proc nguiObsCheckOff { } { nguiObsCheckSetAll 0 }
proc nguiObsCheckOn  { } { nguiObsCheckSetAll 1 }

proc nguiObsCheckSetFilter { F V } {
 global env nocsGlobals nocsWidgets nguiLocals nguiWidgets nocsParams
 set Fu [string trim [string toupper $F]]
 for { set i 1 } { $i <= $nguiLocals(NFILTER) } { incr i } {
  set L [string trim [lindex [split [lindex $nguiLocals(FILTERS) [expr $i - 1]] $nocsGlobals(DELIM)] 1]]
  set V [string trim [lindex [split [lindex $nguiLocals(FILTERS) [expr $i - 1]] $nocsGlobals(DELIM)] 0]]
  if { ${L} == ${Fu} } { set nguiLocals(OBS_C_${i}_VAL) $V }
 }
}
proc nguiObsCheckSetFilterOn  { F } { nguiObsCheckSetFilter $F 1 }
proc nguiObsCheckSetFilterOff { F } { nguiObsCheckSetFilter $F 0 }
