proc nguiSeqFrame { W } {
 global nguiWidgets
 set nguiWidgets(SEQ_F1) [frame ${W}.f1]
 set nguiWidgets(SEQ_F2) [frame ${W}.f2]
 pack $nguiWidgets(SEQ_F1) $nguiWidgets(SEQ_F2) -side top -fill both -expand yes
 nguiSeqF1 $nguiWidgets(SEQ_F1)
 nguiSeqF2 $nguiWidgets(SEQ_F2)
 nguiSeqDisable
}

proc nguiSeqF1 { W } {
 pack [label ${W}.l -bg pink -text "MONSOON CONFIGURATION" -font -adobe-helvetica-bold-r-normal--*-180-*] -expand yes -fill both
}

proc nguiSeqF2 { X } {
 global nguiWidgets nguiLocals nocsGlobals
 for { set i 1 } { $i <= [expr $nguiLocals(NFILTER) - 2] } { incr i } {
  set W [frame ${X}.f${i}]
  pack $W
  set nguiWidgets(SEQ_E_I${i})  [entry ${W}.i${i}   -textvariable nguiLocals(SEQ_E_I${i}_VAL)]
  set nguiWidgets(SEQ_E_C${i})  [spinbox ${W}.c${i} -textvariable nguiLocals(SEQ_E_C${i}_VAL) -increment 1 -from 1 -to 100]
  set nguiWidgets(SEQ_R_B${i}1) [radiobutton ${W}.b${i}1 -bg pink -variable nguiLocals(SEQ_R_B${i}_VAL) -value 400 -text 400]
  set nguiWidgets(SEQ_R_B${i}2) [radiobutton ${W}.b${i}2 -bg pink -variable nguiLocals(SEQ_R_B${i}_VAL) -value 600 -text 600]
  set nguiWidgets(SEQ_R_B${i}3) [radiobutton ${W}.b${i}3 -bg pink -variable nguiLocals(SEQ_R_B${i}_VAL) -value 800 -text 800]
  set nguiWidgets(SEQ_R_F${i}1) [radiobutton ${W}.f${i}1 -bg pink -variable nguiLocals(SEQ_R_F${i}_VAL) -value 1 -text 1]
  set nguiWidgets(SEQ_R_F${i}2) [radiobutton ${W}.f${i}2 -bg pink -variable nguiLocals(SEQ_R_F${i}_VAL) -value 2 -text 2]
  set nguiWidgets(SEQ_R_F${i}3) [radiobutton ${W}.f${i}3 -bg pink -variable nguiLocals(SEQ_R_F${i}_VAL) -value 4 -text 4]
  set nguiWidgets(SEQ_R_F${i}4) [radiobutton ${W}.f${i}4 -bg pink -variable nguiLocals(SEQ_R_F${i}_VAL) -value 8 -text 8]
  set nguiWidgets(SEQ_R_F${i}5) [radiobutton ${W}.f${i}5 -bg pink -variable nguiLocals(SEQ_R_F${i}_VAL) -value 16 -text 16]
  set nguiWidgets(SEQ_R_D${i}1) [radiobutton ${W}.d${i}1 -bg pink -variable nguiLocals(SEQ_R_D${i}_VAL) -value 1 -text 1]
  set nguiWidgets(SEQ_R_D${i}2) [radiobutton ${W}.d${i}2 -bg pink -variable nguiLocals(SEQ_R_D${i}_VAL) -value 2 -text 2]
  set nguiWidgets(SEQ_R_D${i}3) [radiobutton ${W}.d${i}3 -bg pink -variable nguiLocals(SEQ_R_D${i}_VAL) -value 4 -text 4]
  set nguiWidgets(SEQ_R_D${i}4) [radiobutton ${W}.d${i}4 -bg pink -variable nguiLocals(SEQ_R_D${i}_VAL) -value 8 -text 8]
  set nguiWidgets(SEQ_R_D${i}5) [radiobutton ${W}.d${i}5 -bg pink -variable nguiLocals(SEQ_R_D${i}_VAL) -value 16 -text 16]
  set S [string trim [lindex [split [lindex $nguiLocals(FILTERS) [expr $i - 1]] $nocsGlobals(DELIM)] 1]]
  pack [label ${W}.l0 -bg pink -fg blue -text $S -width 8 -anchor e] [label ${W}.l1 -bg pink -text "intTime(sec):" -anchor e] $nguiWidgets(SEQ_E_I${i}) \
       [label ${W}.l2 -bg pink -text "coadds:" -anchor e] $nguiWidgets(SEQ_E_C${i}) \
       [label ${W}.l3 -bg pink -text "bias(mV):" -anchor e] \
       $nguiWidgets(SEQ_R_B${i}1) $nguiWidgets(SEQ_R_B${i}2) $nguiWidgets(SEQ_R_B${i}3) \
       [label ${W}.l4 -bg pink -text "fSamples:" -anchor e] \
       $nguiWidgets(SEQ_R_F${i}1) $nguiWidgets(SEQ_R_F${i}2) $nguiWidgets(SEQ_R_F${i}3) $nguiWidgets(SEQ_R_F${i}4) $nguiWidgets(SEQ_R_F${i}5) \
       [label ${W}.l5 -bg pink -text "digAvgs:" -anchor e] \
       $nguiWidgets(SEQ_R_D${i}1) $nguiWidgets(SEQ_R_D${i}2) $nguiWidgets(SEQ_R_D${i}3) $nguiWidgets(SEQ_R_D${i}4) $nguiWidgets(SEQ_R_D${i}5) \
       -side left -expand yes -fill both
 }
}

proc nguiSeqDisableElement { N } {
 global nguiWidgets nguiLocals
 $nguiWidgets(SEQ_E_I${N})  configure -state disabled
 $nguiWidgets(SEQ_E_C${N})  configure -state disabled
 $nguiWidgets(SEQ_R_B${N}1) configure -state disabled
 $nguiWidgets(SEQ_R_B${N}2) configure -state disabled
 $nguiWidgets(SEQ_R_B${N}3) configure -state disabled
 $nguiWidgets(SEQ_R_F${N}1) configure -state disabled
 $nguiWidgets(SEQ_R_F${N}2) configure -state disabled
 $nguiWidgets(SEQ_R_F${N}3) configure -state disabled
 $nguiWidgets(SEQ_R_F${N}4) configure -state disabled
 $nguiWidgets(SEQ_R_F${N}5) configure -state disabled
 $nguiWidgets(SEQ_R_D${N}1) configure -state disabled
 $nguiWidgets(SEQ_R_D${N}2) configure -state disabled
 $nguiWidgets(SEQ_R_D${N}3) configure -state disabled
 $nguiWidgets(SEQ_R_D${N}4) configure -state disabled
 $nguiWidgets(SEQ_R_D${N}5) configure -state disabled
}

proc nguiSeqDisable { } {
 global nguiWidgets nguiLocals
 for { set i 1 } { $i <= [expr $nguiLocals(NFILTER) - 2] } { incr i } { nguiSeqDisableElement ${i} }
}

proc nguiSeqEnableElement { N } {
 global nguiWidgets nguiLocals nocsGlobals
 $nguiWidgets(SEQ_E_I${N})  configure -state normal
 $nguiWidgets(SEQ_E_C${N})  configure -state normal
 if { $nguiLocals(IBC) == $nocsGlobals(TRUE) } {
  $nguiWidgets(SEQ_R_B${N}1) configure -state normal
  $nguiWidgets(SEQ_R_B${N}2) configure -state normal
  $nguiWidgets(SEQ_R_B${N}3) configure -state normal
 }
 $nguiWidgets(SEQ_R_F${N}1) configure -state normal
 $nguiWidgets(SEQ_R_F${N}2) configure -state normal
 $nguiWidgets(SEQ_R_F${N}3) configure -state normal
 $nguiWidgets(SEQ_R_F${N}4) configure -state normal
 $nguiWidgets(SEQ_R_F${N}5) configure -state normal
 $nguiWidgets(SEQ_R_D${N}1) configure -state normal
 $nguiWidgets(SEQ_R_D${N}2) configure -state normal
 $nguiWidgets(SEQ_R_D${N}3) configure -state normal
 $nguiWidgets(SEQ_R_D${N}4) configure -state normal
 $nguiWidgets(SEQ_R_D${N}5) configure -state normal
}

proc nguiSeqEnable { } {
 global nguiWidgets nguiLocals nocsGlobals
 for { set i 1 } { $i <= [expr $nguiLocals(NFILTER) - 2] } { incr i } { nguiSeqEnableElement $i }
}

proc nguiSeqAddTrace { } {
 global nguiLocals
 for { set i 1 } { $i <= [expr $nguiLocals(NFILTER) - 2] } { incr i } { trace variable nguiLocals(OBS_C_${i}_VAL) w nguiTraceSeq }
}

proc nguiSeqDelTrace { } {
 global nguiLocals
 for { set i 1 } { $i <= [expr $nguiLocals(NFILTER) - 2] } { incr i } { trace vdelete nguiLocals(OBS_C_${i}_VAL) w nguiTraceSeq }
}

proc nguiTraceSeq { name element op } {
 global env nocsErrors nocsGlobals nocsWidgets nguiLocals nguiWidgets
 if { ${element} != "" } { set name ${name}(${element}) }
 upvar ${name} x
 set N [string trim [lindex [split ${element} "_"] 2]]
 nocsInform "nguiTraceSeq <INFO>: name=${name} element=${element} op=${op} N=${N} x=${x}"
 if { ${x} == $nocsGlobals(TRUE) } {
  nguiSeqEnableElement $N
 } else {
  nguiSeqDisableElement $N
 }
}
