proc nguiSetExecHeaderByType { F } {
 global env nocsErrors nocsGlobals nocsWidgets nguiLocals nocsParams nguiWidgets
 if { $F < 0 } { return }
 # script / observation widgets
 puts $F "#+"
 puts $F "# Object             : [nocsDecodeVerbotenChars $nguiLocals(SCR_E_O_VAL)]"
 puts $F "# Script             : $nguiLocals(SCR_E_N_VAL)"
 puts $F "# NumObs             : $nguiLocals(OBS_S_N_VAL)"
 puts $F "# SkyMod             : $nguiLocals(OBS_S_S_VAL)"
 # MONSOON widgets
 switch -exact [string trim [string toupper $nocsParams(NOCDHS)]] {
  DFLATS              { 
   for { set i 1 } { $i <= [expr $nguiLocals(NFILTER) - 2] } { incr i } {
    if { $nguiLocals(OBS_C_${i}_VAL) == $nocsGlobals(TRUE) } {
     puts $F "# Filter             : [string trim [lindex [split [lindex $nguiLocals(FILTERS) [expr ${i} - 1]] $nocsGlobals(DELIM)] 1]] / [string trim [lindex [split [lindex $nguiLocals(FILTERS) [expr ${i} - 1]] $nocsGlobals(DELIM)] 0]] ([string trim [lindex [split [lindex $nguiLocals(FILTERS) [expr ${i} - 1]] $nocsGlobals(DELIM)] 5]])"
     puts $F "#  MONSOON intTime   : $nguiLocals(SEQ_E_I${i}_VAL)"
     puts $F "#  MONSOON coadds    : $nguiLocals(SEQ_E_C${i}_VAL)"
     puts $F "#  MONSOON bias      : $nguiLocals(SEQ_R_B${i}_VAL)"
     puts $F "#  MONSOON fSamples  : $nguiLocals(SEQ_R_F${i}_VAL)"
     puts $F "#  MONSOON digAvgs   : $nguiLocals(SEQ_R_D${i}_VAL)"
    }
   }
  }
  PTCURVE { 
   puts $F "# Filter             : [nguiSetFilterString $nguiLocals(OBS_R_VAL)]"
  }
  default             { 
   puts $F "# Filter             : [nguiSetFilterString $nguiLocals(OBS_R_VAL)]"
   puts $F "# MONSOON intTime    : $nguiLocals(GPX_E_I_VAL)"
   puts $F "# MONSOON coadds     : $nguiLocals(GPX_E_C_VAL)"
   puts $F "# MONSOON bias       : $nguiLocals(GPX_R_B_VAL)"
   puts $F "# MONSOON fSamples   : $nguiLocals(GPX_R_F_VAL)"
   puts $F "# MONSOON digAvgs    : $nguiLocals(GPX_R_D_VAL)"
  }
 }
 # telescope widgets
 switch -exact [string trim [string toupper $nocsParams(NOCDHS)]] {
  FOCUS               -
  TFLAT               -
  SFLAT               -
  SFLATO              -
  STANDARD            -
  DITHERSTARE         -
  QUICKLOOK           -
  DEEPSPARSE          -
  DEEPRICH            -
  QUICKMAP            -
  QUICKMAPWITHSKY     -
  MODMAPSPARSE        -
  MODMAPRICH          {
   puts $F "# Telescope Position : $nguiLocals(TEL_R_VAL)"
   puts $F "# RA                 : $nguiLocals(TEL_E_R_VAL)"
   puts $F "# Dec                : $nguiLocals(TEL_E_D_VAL)"
   puts $F "# Epoch              : $nguiLocals(TEL_E_E_VAL)"
  }
 }
 switch -exact [string trim [string toupper $nocsParams(NOCDHS)]] {
  FOCUS               -
  SFLATO              -
  QUICKLOOK           -
  DEEPRICH            -
  QUICKMAPWITHSKY     -
  MODMAPRICH          {
   puts $F "# RA  offset         : $nguiLocals(TEL_E_OR_VAL)"
   puts $F "# Dec offset         : $nguiLocals(TEL_E_OD_VAL)"
  }
 }
 switch -exact [string trim [string toupper $nocsParams(NOCDHS)]] {
  FOCUS               {
   puts $F "# Focus Start        : $nguiLocals(TEL_E_FS_VAL)"
   puts $F "# Focus Increment    : $nguiLocals(TEL_E_FI_VAL)"
   puts $F "# Focus Step         : $nguiLocals(TEL_E_FN_VAL)"
  }
 }
 # DTH widgets
 switch -exact [string trim [string toupper $nocsParams(NOCDHS)]] {
  SFLAT               -
  SFLATO              -
  STANDARD            -
  DITHERSTARE         -
  DEEPSPARSE          -
  DEEPRICH            -
  QUICKMAP            -
  QUICKMAPWITHSKY     -
  MODMAPSPARSE        -
  MODMAPRICH          {
   puts $F "# Dither Pattern     : $nguiLocals(DTH_R_VAL)"
   puts $F "# Dither RA size     : $nguiLocals(DTH_S_R_VAL)"
   puts $F "# Dither Dec size    : $nguiLocals(DTH_S_D_VAL)"
   puts $F "# Dither iterations  : $nguiLocals(DTH_S_I_VAL)"
   puts $F "# Dither N-step      : $nguiLocals(DTH_S_N_VAL)"
   puts $F "# Dither M-step      : $nguiLocals(DTH_S_M_VAL)"
   puts $F "# Dither File        : $nguiLocals(DTH_E_F_VAL)"
  }
 }
 # MAP widgets
 switch -exact [string trim [string toupper $nocsParams(NOCDHS)]] {
  DEEPSPARSE          -
  DEEPRICH            -
  QUICKMAP            -
  QUICKMAPWITHSKY     -
  MODMAPSPARSE        -
  MODMAPRICH          {
   puts $F "# Map Pattern        : $nguiLocals(MAP_R_VAL)"
   puts $F "# Map RA size        : $nguiLocals(MAP_S_R_VAL)"
   puts $F "# Map Dec size       : $nguiLocals(MAP_S_D_VAL)"
   puts $F "# Map iterations     : $nguiLocals(MAP_S_I_VAL)"
   puts $F "# Map N-step         : $nguiLocals(MAP_S_N_VAL)"
   puts $F "# Map M-step         : $nguiLocals(MAP_S_M_VAL)"
   puts $F "# Map File           : $nguiLocals(MAP_E_F_VAL)"
  }
 }
 puts $F "#-"
}
