proc nguiCheckCoOrd { M } { 
 # remove quotes, periods, colons, +s, -s and spaces
 set S [join [split [string tolower $M] \"] ""]
 set S [join [split $S .] ""]
 set S [join [split $S :] ""]
 set S [join [split $S +] ""]
 set S [join [split $S -] ""]
 set S [string trim [join [split $S " "] ""]]
 # return status
 if { [string is digit $S] } {
  nocsInform "nguiCheckCoOrd <OK>: M=$M, S=<$S> status=[string is digit $S], co-ordinates validated OK"
 } else {
  nocsInform "nguiCheckCoOrd <ERROR>: M=$M, S=<$S> status=[string is digit $S] INVALID CO_ORDINATES"
 }
 return [string is digit $S]
}

proc nguiSetComment { F C } {
 global env nocsGlobals nocsWidgets nguiLocals nguiWidgets
 if { $F < 0 } { return }
 puts $F "# ${C}"
}

proc nguiSetTel { F } {
 global env nocsGlobals nocsWidgets nguiLocals nguiWidgets
 if { $F < 0 } { return }
 set telescopeSlew $nocsGlobals(FALSE)
 switch [string trim [string toupper $nguiLocals(TEL_R_VAL)]] {
  Z {
   set nocsParams(NOCPOST) zenith
   set telescopeSlew $nocsGlobals(TRUE)
  }
  O {
   set nocsParams(NOCPOST) osun
   set telescopeSlew $nocsGlobals(TRUE)
  }
  D {
   set nocsParams(NOCPOST) dfs
   set telescopeSlew $nocsGlobals(TRUE)
  } 
  C {
   set nocsParams(NOCPOST) "$nguiLocals(TEL_E_R_VAL) $nguiLocals(TEL_E_D_VAL) $nguiLocals(TEL_E_E_VAL)"
   set telescopeSlew [nguiCheckCoOrd $nocsParams(NOCPOST)]
  }
 }
 # write telescope slew (currently commented-out for safety reasons which is complete b/s)
 if { $nguiLocals(ISC)==$nocsGlobals(TRUE) && $telescopeSlew==$nocsGlobals(TRUE) } {
 #puts $F "# slew telescope to $nocsParams(NOCPOST)"
 #puts $F "# ditscmd ntcs ntcs_init"
 #puts $F "# ditscmd ntcs ntcs_moveto Argument1=\"$nocsParams(NOCPOST)\""
 #if { $nguiLocals(IEC)==$nocsGlobals(TRUE) } { puts $F "# checkReturnValue \$\? ntcs ntcs_moveto \"$nocsParams(NOCPOST)\"" }
 }
}

proc nguiSetTelOff { F M S } {
 global env nocsGlobals nocsWidgets nguiLocals nguiWidgets
 if { $F < 0 } { return }
 set R [lindex [split ${M} " "] 0]
 set D [lindex [split ${M} " "] 1]
 if { ${R}==0 && ${D}==0 } {
  puts $F "# $S"
  puts $F "# ditscmd ntcs ntcs_init"
  puts $F "# ditscmd ntcs ntcs_offset Argument1=\"${M}\""
  if { $nguiLocals(IEC) == $nocsGlobals(TRUE) } { puts $F "# checkReturnValue \$\? ntcs ntcs_offset \"${M}\"" }
 } else {
  puts $F "# $S"
  puts $F "ditscmd ntcs ntcs_init"
  puts $F "ditscmd ntcs ntcs_offset Argument1=\"${M}\""
  if { $nguiLocals(IEC) == $nocsGlobals(TRUE) } { puts $F "checkReturnValue \$\? ntcs ntcs_offset \"${M}\"" }
 }
}

proc nguiSetTelFocus { F M } {
 global env nocsGlobals nocsWidgets nguiLocals nguiWidgets
 if { $F < 0 } { return }
 puts $F "# set focus"
 puts $F "ditscmd ntcs ntcs_init"
 puts $F "ditscmd ntcs ntcs_focus Argument1=\"${M}\""
 if { $nguiLocals(IEC) == $nocsGlobals(TRUE) } { puts $F "checkReturnValue \$\? ntcs ntcs_focus \"${M}\"" }
}

proc nguiSetFilter { F } {
 global env nocsGlobals nocsWidgets nguiLocals nocsParams nguiWidgets
 if { $F < 0 } { return }
 for { set i 1 } { $i <= $nguiLocals(NFILTER) } { incr i } { 
  set L [string trim [lindex [split [lindex $nguiLocals(FILTERS) [expr $i - 1]] $nocsGlobals(DELIM)] 1]]
  set V [string trim [lindex [split [lindex $nguiLocals(FILTERS) [expr $i - 1]] $nocsGlobals(DELIM)] 0]]
  if { $nocsParams(NOCFIL) == ${V} } { 
   if { $nguiLocals(IFC) == $nocsGlobals(TRUE) } {
    puts $F "# set filter"
    puts $F "ditscmd nics nics_init"
    puts $F "ditscmd nics nics_filter Argument1=\"${V}\""
    if { $nguiLocals(IEC) == $nocsGlobals(TRUE) } { puts $F "checkReturnValue \$\? nics nics_filter \"${V}\"" }
   }
  }
 }
}

proc nguiSleepOrWait { F D M } {
 global env nocsGlobals nocsWidgets nguiLocals nocsParams nguiWidgets
 if { $F < 0 } { return }
 # not dithering, not mapping: allow DHS fix
 if { ${D}==$nocsGlobals(FALSE) && ${M}==$nocsGlobals(FALSE) } {
  if { $nocsParams(NOCNO)==$nocsParams(NOCTOT) && $nocsParams(NOCNO)>1 } {
   puts $F "# add sleep for DHS fix"
   puts $F "echo \"Last observation ... sleeping for 5 seconds for DHS ...\""
   puts $F "sleep 5"
  }
 # dithering, not mapping: allow sleep
 } elseif { ${D}==$nocsGlobals(TRUE) && ${M}==$nocsGlobals(FALSE) } {
  if { [expr abs($nguiLocals(DTH_S_S_VAL))]>0 && $nocsParams(NOCNPOS)==1 } {
   puts $F "# add sleep for telescope/guider fix"
   puts $F "echo \"Dither observation ... sleeping for $nguiLocals(DTH_S_S_VAL) seconds for telescope/guider settling ...\""
   puts $F "sleep $nguiLocals(DTH_S_S_VAL)"
  }
 # not dithering, mapping: allow wait
 } elseif { ${D}==$nocsGlobals(FALSE) && ${M}==$nocsGlobals(TRUE) } {
  if { $nguiLocals(MAP_C_S_VAL)==$nocsGlobals(TRUE) && $nocsParams(NOCNPOS)==1 } {
   puts $F "# add wait for telescope/guider fix"
   puts $F "echo \"Map observation ... waiting for OBSERVER input ...\""
   nguiWaitForReady $F "# not dithering, mapping: allow wait" ""
  }
 # dithering, mapping: wait and/or sleep as appropriate
 } elseif { ${D}==$nocsGlobals(TRUE) && ${M}==$nocsGlobals(TRUE) } {
  #if { $nguiLocals(MAP_C_S_VAL)==$nocsGlobals(TRUE) && $nocsParams(NOCNPOS)==1 } {
  # puts $F "# add wait for telescope/guider fix"
  # puts $F "echo \"Map observation ... waiting for OBSERVER input ...\""
  # nguiWaitForReady $F "# dithering, mapping: allow wait and sleep" ""
  #}
  #if { [expr abs($nguiLocals(DTH_S_S_VAL))]>0 && $nocsParams(NOCNPOS)==1 } {
  # puts $F "# add sleep for telescope/guider fix"
  # puts $F "echo \"Dither observation ... sleeping for $nguiLocals(DTH_S_S_VAL) seconds for telescope/guider settling ...\""
  # puts $F "sleep $nguiLocals(DTH_S_S_VAL)"
  #}
  if { $nguiLocals(MAP_C_S_VAL)==$nocsGlobals(TRUE) && $nocsParams(NOCDPOS)==1 } {
   puts $F "# add wait for telescope/guider fix"
   puts $F "echo \"Map observation ... waiting for OBSERVER input ...\""
   nguiWaitForReady $F "# dithering, mapping: allow wait and sleep" ""
  }
  if { [expr abs($nguiLocals(DTH_S_S_VAL))]>0 && $nocsParams(NOCDPOS)>1 && $nocsParams(NOCNPOS)==1 } {
   puts $F "# add sleep for telescope/guider fix"
   puts $F "echo \"Dither observation ... sleeping for $nguiLocals(DTH_S_S_VAL) seconds for telescope/guider settling ...\""
   puts $F "sleep $nguiLocals(DTH_S_S_VAL)"
  }
 }
}

proc nguiSetObs { F } {
 global env nocsGlobals nocsWidgets nguiLocals nocsParams nguiWidgets
 if { $F < 0 } { return }
 nocsInform "nguiSetObs <$nocsParams(NOCDHS)>: Writing observation $nocsParams(NOCNPOS)/$nocsParams(NOCNUM) as $nocsParams(NOCNO)/$nocsParams(NOCTOT) with DPOS=$nocsParams(NOCDPOS), MPOS=$nocsParams(NOCMPOS), TYPE=$nocsParams(NOCTYP)"

 switch -exact [string trim [string toupper $nocsParams(NOCDHS)]] {
  DARK                { nguiSleepOrWait $F $nocsGlobals(FALSE) $nocsGlobals(FALSE) }
  TEST                { nguiSleepOrWait $F $nocsGlobals(FALSE) $nocsGlobals(FALSE) }
  DFLATON             { nguiSleepOrWait $F $nocsGlobals(FALSE) $nocsGlobals(FALSE) }
  DFLATOFF            { nguiSleepOrWait $F $nocsGlobals(FALSE) $nocsGlobals(FALSE) }
  DFLATS              { nguiSleepOrWait $F $nocsGlobals(FALSE) $nocsGlobals(FALSE) }
  PTCURVE             { nguiSleepOrWait $F $nocsGlobals(FALSE) $nocsGlobals(FALSE) }
  TFLAT               { nguiSleepOrWait $F $nocsGlobals(FALSE) $nocsGlobals(FALSE) }
  SFLAT               { nguiSleepOrWait $F $nocsGlobals(TRUE)  $nocsGlobals(FALSE) }
  SFLATO              { nguiSleepOrWait $F $nocsGlobals(TRUE)  $nocsGlobals(FALSE) }
  STANDARD            { nguiSleepOrWait $F $nocsGlobals(TRUE)  $nocsGlobals(FALSE) }
  FOCUS               { nguiSleepOrWait $F $nocsGlobals(FALSE) $nocsGlobals(FALSE) }
  DITHERSTARE         { nguiSleepOrWait $F $nocsGlobals(TRUE)  $nocsGlobals(FALSE) }
  QUICKLOOK           { nguiSleepOrWait $F $nocsGlobals(FALSE) $nocsGlobals(FALSE) }
  DEEPSPARSE          { nguiSleepOrWait $F $nocsGlobals(TRUE)  $nocsGlobals(TRUE)  }
  DEEPRICH            { nguiSleepOrWait $F $nocsGlobals(TRUE)  $nocsGlobals(TRUE)  }
  QUICKMAP            { nguiSleepOrWait $F $nocsGlobals(TRUE)  $nocsGlobals(TRUE)  }
  QUICKMAPWITHSKY     { nguiSleepOrWait $F $nocsGlobals(TRUE)  $nocsGlobals(TRUE)  }
  MODMAPSPARSE        { nguiSleepOrWait $F $nocsGlobals(TRUE)  $nocsGlobals(TRUE)  }
  MODMAPRICH          { nguiSleepOrWait $F $nocsGlobals(TRUE)  $nocsGlobals(TRUE)  }
 }

 puts $F "# set dynamic expID"
 puts $F "EXPID=\`\$NEWFIRM_BIN/msd\`"
 set nocsParams(NOCID) "\$\{EXPID\}"

 puts $F "# observation $nocsParams(NOCNPOS)/$nocsParams(NOCNUM) as $nocsParams(NOCNO)/$nocsParams(NOCTOT) (DPOS=$nocsParams(NOCDPOS), MPOS=$nocsParams(NOCMPOS))"

 puts $F "ditscmd nohs nohs_init"
 puts $F "ditscmd nohs nohs_newobs Argument1=\"[nguiFormatParams]\""
 if { $nguiLocals(IEC) == $nocsGlobals(TRUE) } { puts $F "checkReturnValue \$\? nohs nohs_newobs \"headers...\"" }

 puts $F "ditscmd nmsl nmsl_init"
 puts $F "ditscmd nmsl nmsl_gpxSetAVP Argument1=\"expID=\$\{EXPID\}\""
 if { $nguiLocals(IEC) == $nocsGlobals(TRUE) } { puts $F "checkReturnValue \$\? nmsl nmsl_gpxSetAVP \"expID=\$\{EXPID\}\"" }

 # quick fix put in for safety reasons
 puts $F "ditscmd nmsl nmsl_init"
 puts $F "ditscmd nmsl nmsl_gpxGetState Argument1=\"IGNORE\""
 puts $F "checkReturnValue \$\? nmsl nmsl_gpxGetState \"IGNORE\""
 # end of quick fix put in for safety reasons

 puts $F "ditscmd nmsl nmsl_init"
 puts $F "ditscmd nmsl nmsl_gpxStartExp"
 if { $nguiLocals(IEC) == $nocsGlobals(TRUE) } { puts $F "checkReturnValue \$\? nmsl nmsl_gpxStartExp \"(none)\"" }

 puts $F "ditscmd nohs nohs_init"
 puts $F "ditscmd nohs nohs_endobs"
 if { $nguiLocals(IEC) == $nocsGlobals(TRUE) } { puts $F "checkReturnValue \$\? nohs nohs_endobs \"(none)\"" }
}

proc nguiSetGpxIntTime { F I } {
 global env nocsErrors nocsGlobals nocsWidgets nguiLocals nguiWidgets
 if { $F < 0 } { return }
 puts $F "# set intTime"
 puts $F "ditscmd nmsl nmsl_init"
 puts $F "ditscmd nmsl nmsl_gpxSetAVP Argument1=\"intTime=$I\""
 if { $nguiLocals(IEC) == $nocsGlobals(TRUE) } { puts $F "checkReturnValue \$\? nmsl nmsl_gpxSetAVP \"intTime=$I\"" }
}

proc nguiSetGpxCoadds { F C } {
 global env nocsErrors nocsGlobals nocsWidgets nguiLocals nguiWidgets
 if { $F < 0 } { return }
 puts $F "# set coadds"
 puts $F "ditscmd nmsl nmsl_init"
 puts $F "ditscmd nmsl nmsl_gpxSetAVP Argument1=\"coadds=$C\""
 if { $nguiLocals(IEC) == $nocsGlobals(TRUE) } { puts $F "checkReturnValue \$\? nmsl nmsl_gpxSetAVP \"coadds=$C\"" }
}

proc nguiSetGpxFSamples { F S } {
 global env nocsErrors nocsGlobals nocsWidgets nguiLocals nguiWidgets
 if { $F < 0 } { return }
 puts $F "# set fSamples"
 puts $F "ditscmd nmsl nmsl_init"
 puts $F "ditscmd nmsl nmsl_gpxSetAVP Argument1=\"fSamples=$S\""
 if { $nguiLocals(IEC) == $nocsGlobals(TRUE) } { puts $F "checkReturnValue \$\? nmsl nmsl_gpxSetAVP \"fSamples=$S\"" }
}

proc nguiSetGpxDigAvgs { F D } {
 global env nocsErrors nocsGlobals nocsWidgets nguiLocals nguiWidgets
 if { $F < 0 } { return }
 puts $F "# set digAvgs"
 puts $F "ditscmd nmsl nmsl_init"
 puts $F "ditscmd nmsl nmsl_gpxSetAVP Argument1=\"digAvgs=$D\""
 if { $nguiLocals(IEC) == $nocsGlobals(TRUE) } { puts $F "checkReturnValue \$\? nmsl nmsl_gpxSetAVP \"digAvgs=$D\"" }
}

proc nguiSetGpxBias { F B } {
 global env nocsErrors nocsGlobals nocsWidgets nguiLocals nguiWidgets
 if { $F < 0 } { return }
 if { $nguiLocals(IBC) == $nocsGlobals(TRUE) } {
  puts $F "# disable sequencer"
  puts $F "ditscmd nmsl nmsl_init"
  puts $F "ditscmd nmsl nmsl_gpxSetAVP Argument1=\"mcbSeqEnable=0\""
  if { $nguiLocals(IEC) == $nocsGlobals(TRUE) } { puts $F "checkReturnValue \$\? nmsl nmsl_gpxSetAVP \"mcbSeqEnable=0\"" }
  puts $F "# set mode"
  puts $F "ditscmd nmsl nmsl_init"
  set BF [string tolower [string trim ${B}]mvbias.mod]
  puts $F "ditscmd nmsl nmsl_gpxSetMode Argument1=\"$BF\""
  if { $nguiLocals(IEC) == $nocsGlobals(TRUE) } { puts $F "checkReturnValue \$\? nmsl nmsl_gpxSetMode \"$BF\"" }
  puts $F "# enable sequencer"
  puts $F "ditscmd nmsl nmsl_init"
  puts $F "ditscmd nmsl nmsl_gpxSetAVP Argument1=\"mcbSeqEnable=1\""
  if { $nguiLocals(IEC) == $nocsGlobals(TRUE) } { puts $F "checkReturnValue \$\? nmsl nmsl_gpxSetAVP \"mcbSeqEnable=1\"" }
 }
}

proc nguiSetGpx { F I C S D B } {
 global env nocsErrors nocsGlobals nocsWidgets nguiLocals nguiWidgets
 if { $F < 0 } { return }
 nguiSetGpxIntTime  $F $I
 nguiSetGpxCoadds   $F $C
 nguiSetGpxFSamples $F $S
 nguiSetGpxDigAvgs  $F $D
 nguiSetGpxBias     $F $B
}

proc nguiGmodeOff { F } {
 global env nocsErrors nocsGlobals nocsWidgets nguiLocals nguiWidgets
 if { $F < 0 } { return }
 puts $F "# disable guider"
 puts $F "ditscmd ntcs ntcs_init"
 puts $F "ditscmd ntcs ntcs_gmode Argument1=\"off\""
 if { $nguiLocals(IEC)==$nocsGlobals(TRUE) } { puts $F "checkReturnValue \$\? ntcs ntcs_gmode \"off\"" }
}
