proc nguiSetProjectQuit { W } {
 return [destroy $W]
}

proc nguiProjectInit { X } {
 global env projParams
 if { [file exists ${X}] == 0 } { return }
 set F [open ${X} r]
 while {[gets ${F} T] >= 0} {
  if { [string index $T 0] != "#" } {
   set L [split $T "\\"]
   set K [string trim [lindex $L 0]]
   set C [string trim [lindex $L 1]]
   set V [string trim [lindex $L 2]]
   set projParams($K) $V
  }
 }
 close $F
}

proc nguiProjectReInit { X } {
 global env projParams
 if { [file exists ${X}] == 0 } { exec rm -f ${X} }
 set F [open ${X} w]
 puts $F [format "NOCPI   \\ Principal Investigator \\ %s" [string trim $projParams(NOCPI)]]
 puts $F [format "NOCPIE  \\ PIs E-mail Address     \\ %s" [string trim $projParams(NOCPIE)]]
 puts $F [format "NOCAO   \\ Actual Observer(s)     \\ %s" [string trim $projParams(NOCAO)]]
 puts $F [format "NOCAOE  \\ AOs E-mail Address     \\ %s" [string trim $projParams(NOCAOE)]]
 puts $F [format "NOCOA   \\ Observing Assistant    \\ %s" [string trim $projParams(NOCOA)]]
 puts $F [format "NOCOAE  \\ OAs E-mail Address     \\ %s" [string trim $projParams(NOCOAE)]]
 puts $F [format "NOCPROP \\ Proposal Identifier    \\ %s" [string trim $projParams(NOCPROP)]]
 puts $F [format "NOCTEL  \\ Telescope System       \\ %s" [string trim $projParams(NOCTEL)]]
 flush $F
 close $F
}

proc nguiSetProjectSave { W } {
 global env projParams nguiWidgets
 set projParams(NOCPI)   [string trim [$nguiWidgets(GUI_PI) get]]
 set projParams(NOCPIE)  [string trim [$nguiWidgets(GUI_PIE) get]]
 set projParams(NOCAO)   [string trim [$nguiWidgets(GUI_ABS) get]]
 set projParams(NOCAOE)  [string trim [$nguiWidgets(GUI_ABSE) get]]
 set projParams(NOCOA)   [string trim [$nguiWidgets(GUI_OBS) get]]
 set projParams(NOCOAE)  [string trim [$nguiWidgets(GUI_OBSE) get]]
 set projParams(NOCPROP) [string trim [$nguiWidgets(GUI_PROP) get]]
 set projParams(NOCTEL)  [string trim [$nguiWidgets(GUI_TEL) get]]
 nocsInform "nguiSetProjectSave <INFO>: Principal Investigator: $projParams(NOCPI)"
 nocsInform "nguiSetProjectSave <INFO>: PIs Email: $projParams(NOCPIE)"
 nocsInform "nguiSetProjectSave <INFO>: Actual Observer(s): $projParams(NOCAO)"
 nocsInform "nguiSetProjectSave <INFO>: AOs Email: $projParams(NOCAOE)"
 nocsInform "nguiSetProjectSave <INFO>: Observing Assistant: $projParams(NOCOA)"
 nocsInform "nguiSetProjectSave <INFO>: OAs Email: $projParams(NOCOAE)"
 nocsInform "nguiSetProjectSave <INFO>: Proposal: $projParams(NOCPROP)"
 nocsInform "nguiSetProjectSave <INFO>: Telescope: $projParams(NOCTEL)"
 nguiProjectReInit $env(HOME)/.ngui
 nguiSetProjectQuit $W
}

proc nguiSetProject { W } {
 # global(s)
 global env nguiWidgets

 # top level and frame(s)
 if { [winfo exists $W] } { destroy $W }
 toplevel $W
 wm title $W "Set Project Parameter(s)"
 set U [frame ${W}.u]
 set L [frame ${W}.l]
 pack $U $L -in $W -side top -fill both -expand yes

 # create Save and Quit buttons
 set nguiWidgets(GUI_SAVE) [button ${L}.ok -text Save]
 pack $nguiWidgets(GUI_SAVE) -in $L -side left -fill both -expand y
 $nguiWidgets(GUI_SAVE) configure -command { nguiSetProjectSave [winfo parent [winfo parent $nguiWidgets(GUI_SAVE)]] }

 # init params
 nguiProjectInit $env(HOME)/.ngui

 # create project parameter(s)
 set U1 [frame ${U}.u1]
 set U2 [frame ${U}.u2]
 set U3 [frame ${U}.u3]
 set U4 [frame ${U}.u4]
 set U5 [frame ${U}.u5]
 set U6 [frame ${U}.u6]
 set U7 [frame ${U}.u7]
 set U8 [frame ${U}.u8]
 pack $U1 $U2 $U3 $U4 $U5 $U6 $U7 $U8 -side top -fill both -expand yes
 set nguiWidgets(GUI_PI)   [entry ${U1}.e -width 50 -textvariable projParams(NOCPI)]
 set nguiWidgets(GUI_PIE)  [entry ${U2}.e -width 50 -textvariable projParams(NOCPIE)]
 set nguiWidgets(GUI_ABS)  [entry ${U3}.e -width 50 -textvariable projParams(NOCAO)]
 set nguiWidgets(GUI_ABSE) [entry ${U4}.e -width 50 -textvariable projParams(NOCAOE)]
 set nguiWidgets(GUI_OBS)  [entry ${U5}.e -width 50 -textvariable projParams(NOCOA)]
 set nguiWidgets(GUI_OBSE) [entry ${U6}.e -width 50 -textvariable projParams(NOCOAE)]
 set nguiWidgets(GUI_PROP) [entry ${U7}.e -width 50 -textvariable projParams(NOCPROP)]
 set nguiWidgets(GUI_TEL)  [entry ${U8}.e -width 50 -textvariable projParams(NOCTEL)]
 pack [label ${U1}.l -text "Principal Investigator:" -width 20 -anchor e] $nguiWidgets(GUI_PI) -side left -fill both -expand y
 pack [label ${U2}.l -text "PIs Email Address:" -width 20 -anchor e] $nguiWidgets(GUI_PIE) -side left -fill both -expand y
 pack [label ${U3}.l -text "Actual Observer(s):" -width 20 -anchor e] $nguiWidgets(GUI_ABS) -side left -fill both -expand y
 pack [label ${U4}.l -text "AOs Email Address:" -width 20 -anchor e] $nguiWidgets(GUI_ABSE) -side left -fill both -expand y
 pack [label ${U5}.l -text "Observing Assistant:" -width 20 -anchor e] $nguiWidgets(GUI_OBS) -side left -fill both -expand y
 pack [label ${U6}.l -text "OAs Email Address:" -width 20 -anchor e] $nguiWidgets(GUI_OBSE) -side left -fill both -expand y
 pack [label ${U7}.l -text "Proposal Identifier:" -width 20 -anchor e] $nguiWidgets(GUI_PROP) -side left -fill both -expand y
 pack [label ${U8}.l -text "Telescope System:" -width 20 -anchor e] $nguiWidgets(GUI_TEL) -side left -fill both -expand y
}
