proc nguiTelFrame { W } {
 global nguiWidgets
 set nguiWidgets(TEL_F1) [frame ${W}.f1]
 set nguiWidgets(TEL_F2) [frame ${W}.f2]
 set nguiWidgets(TEL_F3) [frame ${W}.f3]
 pack $nguiWidgets(TEL_F1) $nguiWidgets(TEL_F2) $nguiWidgets(TEL_F3) -side top -fill both -expand yes
 set nguiWidgets(TEL_F4) [frame $nguiWidgets(TEL_F2).l]
 set nguiWidgets(TEL_F5) [frame $nguiWidgets(TEL_F2).r]
 pack $nguiWidgets(TEL_F4) $nguiWidgets(TEL_F5) -side left -fill both -expand yes
 set nguiWidgets(TEL_F6) [frame $nguiWidgets(TEL_F3).l]
 set nguiWidgets(TEL_F7) [frame $nguiWidgets(TEL_F3).r]
 pack $nguiWidgets(TEL_F6) $nguiWidgets(TEL_F7) -side left -fill both -expand yes
 nguiTelF1 $nguiWidgets(TEL_F1)
 nguiTelF4 $nguiWidgets(TEL_F4)
 nguiTelF5 $nguiWidgets(TEL_F5)
 nguiTelF6 $nguiWidgets(TEL_F6)
 nguiTelF7 $nguiWidgets(TEL_F7)
 nguiTelDisable
}

proc nguiTelF1 { W } {
 pack [label ${W}.l -bg thistle -fg black -text "TELESCOPE CONFIGURATION" -font -adobe-helvetica-bold-r-normal--*-180-*] -expand yes -fill both
}

proc nguiTelF2 { W } { }

proc nguiTelF3 { W } { }

proc nguiTelF4 { W } {
 global nguiWidgets nguiLocals
 set nguiWidgets(TEL_R_Z) [radiobutton ${W}.rz -bg thistle -variable nguiLocals(TEL_R_VAL) -value Z -text Zenith]
 set nguiWidgets(TEL_R_O) [radiobutton ${W}.ro -bg thistle -variable nguiLocals(TEL_R_VAL) -value O -text O-Sun]
 set nguiWidgets(TEL_R_D) [radiobutton ${W}.rd -bg thistle -variable nguiLocals(TEL_R_VAL) -value D -text DFS]
 set nguiWidgets(TEL_R_C) [radiobutton ${W}.rc -bg thistle -variable nguiLocals(TEL_R_VAL) -value C -text CoOrd]
 pack [label ${W}.l1 -bg thistle -text "POSITION: " -anchor w] \
      $nguiWidgets(TEL_R_Z) $nguiWidgets(TEL_R_O) $nguiWidgets(TEL_R_D) $nguiWidgets(TEL_R_C) -side left -fill both -expand yes
}

proc nguiTelF5 { W } {
 global nguiWidgets nguiLocals
 set nguiWidgets(TEL_E_R) [entry ${W}.r -textvariable nguiLocals(TEL_E_R_VAL) -width 10]
 set nguiWidgets(TEL_E_D) [entry ${W}.d -textvariable nguiLocals(TEL_E_D_VAL) -width 10]
 set nguiWidgets(TEL_E_E) [entry ${W}.e -textvariable nguiLocals(TEL_E_E_VAL)]
 pack $nguiWidgets(TEL_E_E) [label ${W}.l4 -bg thistle -text "Epoch: " -anchor e] \
      $nguiWidgets(TEL_E_D) [label ${W}.l3 -bg thistle -text "Dec: " -anchor e] \
      $nguiWidgets(TEL_E_R) [label ${W}.l2 -bg thistle -text "RA: " -anchor e] -side right -fill both -expand yes
}

proc nguiTelF6 { W } {
 global nguiWidgets nguiLocals
 set nguiWidgets(TEL_E_OR) [entry ${W}.or -textvariable nguiLocals(TEL_E_OR_VAL)]
 set nguiWidgets(TEL_E_OD) [entry ${W}.od -textvariable nguiLocals(TEL_E_OD_VAL)]
 pack [label ${W}.l1 -bg thistle -text "OFFSET: " -anchor w] \
      [label ${W}.l2 -bg thistle -text "RA (''): " -anchor e] $nguiWidgets(TEL_E_OR) \
      [label ${W}.l4 -bg thistle -text "Dec (''): " -anchor e] $nguiWidgets(TEL_E_OD) -side left -fill both -expand yes
}

proc nguiTelF7 { W } {
 global nguiWidgets nguiLocals
 set nguiWidgets(TEL_E_FS) [entry ${W}.fs -textvariable nguiLocals(TEL_E_FS_VAL)]
 set nguiWidgets(TEL_E_FI) [entry ${W}.fi -textvariable nguiLocals(TEL_E_FI_VAL)]
 set nguiWidgets(TEL_E_FN) [spinbox ${W}.fn -textvariable nguiLocals(TEL_E_FN_VAL) -increment 1 -from 2 -to 100]
 pack [label ${W}.l1 -bg thistle -text "FOCUS: " -anchor w] \
      [label ${W}.l2 -bg thistle -text "Start Focus (\u03bcm): " -anchor e] $nguiWidgets(TEL_E_FS) \
      [label ${W}.l4 -bg thistle -text "Step Size (\u03bcm): " -anchor e] $nguiWidgets(TEL_E_FI) \
      [label ${W}.l6 -bg thistle -text "# Focus Steps: " -anchor e] $nguiWidgets(TEL_E_FN) -side left -fill both -expand yes
}

proc nguiTelDisable { } {
 global nguiWidgets
 $nguiWidgets(TEL_E_R)  configure -state disabled
 $nguiWidgets(TEL_E_D)  configure -state disabled
 $nguiWidgets(TEL_E_E)  configure -state disabled
 $nguiWidgets(TEL_R_Z)  configure -state disabled
 $nguiWidgets(TEL_R_O)  configure -state disabled
 $nguiWidgets(TEL_R_D)  configure -state disabled
 $nguiWidgets(TEL_R_C)  configure -state disabled
 $nguiWidgets(TEL_E_OR) configure -state disabled
 $nguiWidgets(TEL_E_OD) configure -state disabled
 $nguiWidgets(TEL_E_FS) configure -state disabled
 $nguiWidgets(TEL_E_FI) configure -state disabled
 $nguiWidgets(TEL_E_FN) configure -state disabled
}

proc nguiTelEnable { } {
 global nguiWidgets
 $nguiWidgets(TEL_E_R)  configure -state normal
 $nguiWidgets(TEL_E_D)  configure -state normal
 $nguiWidgets(TEL_E_E)  configure -state normal
 $nguiWidgets(TEL_R_Z)  configure -state normal
 $nguiWidgets(TEL_R_O)  configure -state normal
 $nguiWidgets(TEL_R_D)  configure -state normal
 $nguiWidgets(TEL_R_C)  configure -state normal
 $nguiWidgets(TEL_E_OR) configure -state normal
 $nguiWidgets(TEL_E_OD) configure -state normal
 $nguiWidgets(TEL_E_FS) configure -state normal
 $nguiWidgets(TEL_E_FI) configure -state normal
 $nguiWidgets(TEL_E_FN) configure -state normal
}

proc nguiTelEnableByFlag { F1 F2 F3 F4 F5 F6 F7 F8 F9 FA FB FC } {
 global nguiWidgets nocsGlobals
 if { $F1 == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_E_R)  configure -state normal }
 if { $F2 == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_E_D)  configure -state normal }
 if { $F3 == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_E_E)  configure -state normal }
 if { $F4 == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_R_Z)  configure -state normal }
 if { $F5 == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_R_O)  configure -state normal }
 if { $F6 == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_R_D)  configure -state normal }
 if { $F7 == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_R_C)  configure -state normal }
 if { $F8 == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_E_OR) configure -state normal }
 if { $F9 == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_E_OD) configure -state normal }
 if { $FA == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_E_FS) configure -state normal }
 if { $FB == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_E_FI) configure -state normal }
 if { $FC == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_E_FN) configure -state normal }
}

proc nguiTelDisableByFlag { F1 F2 F3 F4 F5 F6 F7 F8 F9 FA FB FC } {
 global nguiWidgets nocsGlobals
 if { $F1 == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_E_R)  configure -state disabled }
 if { $F2 == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_E_D)  configure -state disabled }
 if { $F3 == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_E_E)  configure -state disabled }
 if { $F4 == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_R_Z)  configure -state disabled }
 if { $F5 == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_R_O)  configure -state disabled }
 if { $F6 == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_R_D)  configure -state disabled }
 if { $F7 == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_R_C)  configure -state disabled }
 if { $F8 == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_E_OR) configure -state disabled }
 if { $F9 == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_E_OD) configure -state disabled }
 if { $FA == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_E_FS) configure -state disabled }
 if { $FB == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_E_FI) configure -state disabled }
 if { $FC == $nocsGlobals(TRUE) } { $nguiWidgets(TEL_E_FN) configure -state disabled }
}

proc nguiTelAddTrace { } {
 global nguiLocals
 trace variable nguiLocals(TEL_R_VAL) w nguiTraceTelescope
}

proc nguiTelDelTrace { } {
 global nguiLocals
 trace vdelete nguiLocals(TEL_R_VAL) w nguiTraceTelescope
}

proc nguiTraceTelescope { name element op } {
 global env nocsErrors nocsGlobals nocsWidgets nguiLocals nguiWidgets
 if { ${element} != "" } { set name ${name}(${element}) }
 upvar ${name} x
 switch -regexp [string trim [string toupper ${x}]] {
  O -
  D -
  Z { nguiTelDisableByFlag 1 1 1 0 0 0 0 0 0 0 0 0 }
  C { nguiTelEnableByFlag  1 1 1 0 0 0 0 0 0 0 0 0 }
 }
}
