proc nocsInitVersions { } {
 global env nocsGlobals nocsVersions tcl_version tk_version
 set nocsVersions(TCL)      $tcl_version
 set nocsVersions(TK)       $tk_version
 set nocsVersions(AUTHOR)   "Philip N. Daly"
 set nocsVersions(EMAIL)    "pnd@noao.edu"
 set nocsVersions(DATE)     "16 July, 2009"
 set nocsVersions(VERSION)  20090716
 set nocsVersions(MODULE)   NGUI
 set nocsVersions(OWNER)    "(C) 2007-2008 AURA Inc."
 set nocsVersions(HELP)     ""
 append nocsVersions(HELP)  $nocsVersions(MODULE) ":\tv" $nocsVersions(VERSION) "\n"
 append nocsVersions(HELP)  $nocsVersions(OWNER)  "\n"
 append nocsVersions(HELP)  "Author:\t"  $nocsVersions(AUTHOR) "\n"
 append nocsVersions(HELP)  "E-mail:\t"  $nocsVersions(EMAIL)  "\n"
 append nocsVersions(HELP)  "Date:\t"    $nocsVersions(DATE)   "\n"
 append nocsVersions(HELP)  "Tcl:\tv"    $nocsVersions(TCL)    "\n"
 append nocsVersions(HELP)  "Tk:\tv"     $nocsVersions(TK)     "\n"
}

proc nocsInitGlobals { } {
 global env nocsGlobals
 set nocsGlobals(FALSE)   0
 set nocsGlobals(TRUE)    1
 set nocsGlobals(NOTSET)  -1
 set nocsGlobals(SYSLEV)  .$env(NGUI_TELESCOPE)
 set nocsGlobals(SYSTEM)  $env(NGUI_TELESCOPE)
 set nocsGlobals(SDATE)   $nocsGlobals(TRUE)
 set nocsGlobals(FITS)    $nocsGlobals(TRUE)
 set nocsGlobals(PORT)    $nocsGlobals(NOTSET)
 set nocsGlobals(GID)     0.0
 set nocsGlobals(DELAY)   500
 set nocsGlobals(RETRIES) 10
 set nocsGlobals(TIMEOUT) 500
 set nocsGlobals(SS_OK)   {}
 set nocsGlobals(SSD_OK)  {}
 set nocsGlobals(DELIM)   "\\"
 set nocsGlobals(CONFIG)  $env(HOME)/.ngui
}

proc nocsAbout { W } {
 global nocsVersions
 tk_dialog ${W}.dialog "About $nocsVersions(MODULE)" $nocsVersions(HELP) info 0 Dismiss
 return 0
}

proc nocsClear { } {
 global nocsWidgets
 $nocsWidgets(TW) configure -state normal
 $nocsWidgets(TW) delete 1.0 end
 $nocsWidgets(TW) configure -state disabled
}

proc nocsStringMatch { P S } {
 global nocsWidgets
 if { $nocsWidgets(TW) != "" } {
  scan [$nocsWidgets(TW) index end] %d n
  for {set i 1} {$i < $n} {incr i} {
   $nocsWidgets(TW) delete 0.0 1.0
   $nocsWidgets(TW) mark set last $i.0
   while {[regexp -indices $P [$nocsWidgets(TW) get last "last lineend"] x]} {
    $nocsWidgets(TW) mark set first "last + [lindex $x 0] chars"
    $nocsWidgets(TW) mark set last "last + 1 chars + [lindex $x 1] chars"
    uplevel $S
   }
  }
 }
}

proc nocsInform { M } {
 global env nocsGlobals nocsWidgets
 if { $nocsWidgets(TW) != "" } {
  scan [$nocsWidgets(TW) index end] %d N
  if { $N > 750 } { nocsClear }
  $nocsWidgets(TW) configure -state normal
  $nocsWidgets(TW) insert end "$M\n"
  $nocsWidgets(TW) yview -pickplace end
  $nocsWidgets(TW) configure -state disabled
  nocsStringMatch ERROR " $nocsWidgets(TW) tag add errs first last "
 }
}

proc nocsSetXopts { F } {
 global nocsXopts
 if { [file exists $F] == 0 } { return }
 set D [open $F r]
 while { [gets $D T] >= 0 } {
  if { ([llength $T]==2) && ([string index $T 0]!="#") } { set nocsXopts([lindex $T 0]) [lindex $T 1] }
 }
 close $D
 foreach O [array names nocsXopts {x*}] { option add *[string range $O 1 end] $nocsXopts($O) }
}

proc nocsSaveConfirm { W } {
#if { [winfo exists $W] } { return [tk_dialog ${W}.confirm "Save Parameter(s)" "Save Current Parameter(s)?" question 0 Yes No] }
 if { [winfo exists $W] } { return [tk_dialog ${W}.confirm "Exit Application Dialogue" "Exit and/or Save Current Setting(s)?" question 0 "Save and Exit" "Just Exit" Dismiss] }
}

proc nocsExit { W L } {
 global env
 switch [nocsSaveConfirm $W] {
  0 { nguiWriteValues $env(NGUI_PARS); exit $L }
  1 { exit $L }
  default { }
 }
}

proc nocsShowParams { } {
 global nocsParams
 foreach E [array names nocsParams] { nocsInform "nocsShowParams <INFO>: $E = $nocsParams($E)" }
}

proc nocsShowComments { } {
 global nocsComments
 foreach E [array names nocsComments] { nocsInform "nocsShowComments <INFO>: $E = $nocsComments($E)" }
}

proc nocsShowEnv { } {
 global env
 foreach E [array names env] { nocsInform "nocsShowEnv <INFO>: $E = $env($E)" }
}

proc nocsShowGlobals { } {
 global nocsGlobals
 foreach E [array names nocsGlobals] { nocsInform "nocsShowGlobals <INFO>: nocsGlobals($E) = \"$nocsGlobals($E)\"" }
}

proc nocsShow { W } {
 global env nocsGlobals nocsStreams nocsWidgets gpxPending gpxStatus gwcPending gwcStatus
 switch [string toupper [string trim $W]] {
  COM { nocsShowComments }
  ENV { nocsShowEnv }
  GBL { nocsShowGlobals }
  PAR { nocsShowParams }
  default -
  DEFAULT { nocsInform "nocsShow: [environment] [subscription] [stream]" }
 }
}

proc nocsParamsInit { } {
 global env nocsGlobals nocsStreams nocsComments nocsKeywords nocsParams
 set F [open $env(NOCS_GWC) r]
 while {[gets ${F} T] >= 0} {
  if { [string index $T 0] != "#" } {
   set L [split $T $nocsGlobals(DELIM)]
   set K [string trim [string toupper [lindex $L 0]]]
   set S [string trim [string tolower [lindex $L 1]]]
   set C [string trim [string tolower [lindex $L 2]]]
   set D [string trim [lindex $L 3]]
   set nocsComments($S) $C
   set nocsKeywords($S) $K
   set Q  [split $S .]
   set Q0 [string trim [string tolower [lindex $Q 0]]]
   set Q1 [string trim [string tolower [lindex $Q 1]]]
   set st [format "%s.%s" $Q0 $Q1]
   if { [lsearch $nocsGlobals(SS_OK) $st] < 0 } { lappend nocsGlobals(SS_OK) $st }
   lappend nocsGlobals(SSD_OK) $S
   set nocsStreams($S) "\'$D\' string ok $K"
   nocsInform "nocsParamsInit <INFO>: $S registered OK"
   set nocsParams($K) $D
  }
 }
 close $F
 return
}

proc nocsCleanStr { T } {
 set T  [join [split ${T} "\""] ""]
 set T  [join [split ${T} "\'"] ""]
 set T  [join [split ${T} "\\"] ""]
 set T  [join [split ${T} "="]  ""]
 set T  [join [split ${T} "@"]  ""]
 return [join [split ${T} " "]   _]
}

proc nocsUnCleanStr { T } {
 return [join [split ${T} _] " "]
}

proc nocsEncodeVerbotenChars { E } {
 set I [regsub -all {\ } ${E} ".ws." E]
 set I [regsub -all {\"} ${E} ".dq." E]
 set I [regsub -all {\'} ${E} ".sq." E]
 set I [regsub -all {\=} ${E} ".eq." E]
 set I [regsub -all {\_} ${E} ".us." E]
 set I [regsub -all {\@} ${E} ".at." E]
 #set I [regsub -all {\\} ${E} ".bs." E]
 return ${E}
}

proc nocsDecodeVerbotenChars { D } {
 set I [regsub -all {\.ws\.} ${D} "\ " D]
 set I [regsub -all {\.dq\.} ${D} "\"" D]
 set I [regsub -all {\.sq\.} ${D} "\'" D]
 set I [regsub -all {\.eq\.} ${D} "\=" D]
 set I [regsub -all {\.us\.} ${D} "\_" D]
 set I [regsub -all {\.at\.} ${D} "\@" D]
 #set I [regsub -all {\.bs\.} ${D} {\\} D]
 return ${D}
}

proc nocsFrameCancel { F W } {
 global nocsParams
 nguiGetValues [string trim [string tolower $nocsParams(NOCDHS)]]
 if { $F < 0 } {
  nocsInform "nocsFrameCancel <INFO>: invalid file descriptor"
 } else {
  return [destroy $W]
 }
}
